import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-dialog.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-overlay.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import { watch as B, nextTick as O, ref as s, resolveComponent as D, openBlock as C, createBlock as R, unref as m, isRef as I, withCtx as i, createElementVNode as U, createVNode as c, createTextVNode as b, toDisplayString as y } from "vue";
import r from "../../../store/index.js";
import "./TableDialog.vue2.js";
import { ElButton as j } from "../../../../../node_modules/element-plus/es/components/button/index.js";
import { ElDialog as A } from "../../../../../node_modules/element-plus/es/components/dialog/index.js";
const E = { class: "dialog-footer" }, L = {
  __name: "TableDialog",
  props: {
    modelValue: {
      type: Boolean,
      default: !1
    },
    tableId: {
      type: String,
      default: ""
    },
    initOption: {
      type: Object,
      default: {
        width: "",
        value: ""
      }
    },
    initSearchData: {
      type: Object,
      default: {}
    },
    title: {
      type: String,
      default: "选择列表"
    },
    entitle: {
      type: String,
      default: "title"
    },
    width: {
      type: String,
      default: "50%"
    },
    class: {
      type: String,
      default: ""
    },
    submitButtonText: {
      type: String,
      default: "确 定"
    },
    cancelButtonText: {
      type: String,
      default: "取 消"
    },
    ensubmitButtonText: {
      type: String,
      default: "ok"
    },
    encancelButtonText: {
      type: String,
      default: "cancel"
    },
    selectType: {
      type: String,
      default: "checkbox"
    },
    selectValue: {
      type: Object,
      default: []
    },
    selectKey: {
      type: String,
      default: ""
    }
  },
  emits: ["submit", "update:modelValue"],
  setup(g, { emit: S }) {
    const t = g;
    B(
      () => t.modelValue,
      (e) => {
        e && (a.value = e, k(), O(() => {
          v();
        }));
      }
    );
    const a = s(!1), p = S, _ = () => {
      p("update:modelValue", !1);
    }, u = s();
    function h() {
      let e = [];
      e = u.value.getSelectionRows(), p("submit", e), a.value = !1;
    }
    const o = s({});
    function k() {
      let e = t.initOption;
      e.isInDialog = !0, e.isAutoHeight = !0;
      let l = t.selectValue;
      t.selectValue && !Array.isArray(t.selectValue) && (l = t.selectValue.split(","));
      let n = e.pkey || t.selectKey;
      e.pkey = n, t.selectType == "checkbox" ? (e.isSelect = !0, e.selectKey = n) : e.isRadio = !0, e.value = l, o.value = e;
    }
    function v() {
      o.value.value && u.value.setSelectionRows(o.value.value);
    }
    function x() {
      let e = "";
      switch (r.getters.i18n) {
        case "en_US":
          e = t.entitle;
          break;
        default:
          e = t.title || "标题";
          break;
      }
      return e;
    }
    function T() {
      let e = "";
      switch (r.getters.i18n) {
        case "en_US":
          e = t.encancelButtonText;
          break;
        default:
          e = t.cancelButtonText;
          break;
      }
      return e;
    }
    function V() {
      let e = "";
      switch (r.getters.i18n) {
        case "en_US":
          e = t.ensubmitButtonText;
          break;
        default:
          e = t.submitButtonText;
          break;
      }
      return e;
    }
    return (e, l) => {
      const n = D("h-table"), d = j, w = A;
      return C(), R(w, {
        modelValue: m(a),
        "onUpdate:modelValue": l[1] || (l[1] = (f) => I(a) ? a.value = f : null),
        title: x(),
        onClose: _,
        "destroy-on-close": "",
        draggable: "",
        "append-to-body": "",
        "close-on-click-modal": !1,
        "close-on-press-escape": !1,
        width: t.initOption.width || t.width,
        "custom-class": t.class + " custom-dialog"
      }, {
        footer: i(() => [
          U("span", E, [
            c(d, {
              onClick: l[0] || (l[0] = (f) => a.value = !1)
            }, {
              default: i(() => [
                b(y(T()), 1)
              ]),
              _: 1
            }),
            c(d, {
              type: "primary",
              onClick: h
            }, {
              default: i(() => [
                b(y(V()), 1)
              ]),
              _: 1
            })
          ])
        ]),
        default: i(() => [
          c(n, {
            tableId: t.tableId,
            initOption: m(o),
            initSearchData: t.initSearchData,
            ref_key: "tableRef",
            ref: u
          }, null, 8, ["tableId", "initOption", "initSearchData"])
        ]),
        _: 1
      }, 8, ["modelValue", "title", "width", "custom-class"]);
    };
  }
};
export {
  L as default
};
