import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-dialog.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-overlay.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-tree.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-checkbox.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-radio.css.js";
import { watch as q, nextTick as F, ref as s, computed as j, openBlock as y, createBlock as J, unref as p, isRef as v, withCtx as o, createElementVNode as T, createVNode as c, createTextVNode as g, toDisplayString as f, createElementBlock as w, Fragment as U, withModifiers as $ } from "vue";
import "./TreeDialog.vue2.js";
import { ElRadio as A } from "../../../../../node_modules/element-plus/es/components/radio/index.js";
import { ElTree as M } from "../../../../../node_modules/element-plus/es/components/tree/index.js";
import { ElScrollbar as z } from "../../../../../node_modules/element-plus/es/components/scrollbar/index.js";
import { ElButton as G } from "../../../../../node_modules/element-plus/es/components/button/index.js";
import { ElDialog as H } from "../../../../../node_modules/element-plus/es/components/dialog/index.js";
const I = { key: 1 }, L = { class: "dialog-footer" }, ie = {
  __name: "TreeDialog",
  props: {
    modelValue: {
      type: Boolean,
      default: !1
    },
    title: {
      type: String,
      default: "选择树形"
    },
    width: {
      type: String,
      default: "50%"
    },
    class: {
      type: String,
      default: ""
    },
    submitButtonText: {
      type: String,
      default: "确 定"
    },
    cancelButtonText: {
      type: String,
      default: "取 消"
    },
    data: {
      type: Object,
      default: []
    },
    selectType: {
      type: String,
      default: "checkbox"
    },
    selectValue: {
      type: Object,
      default: []
    },
    selectKey: {
      type: String,
      required: !0
    },
    parentSelectKey: {
      type: String,
      required: !0
    },
    showFieldName: {
      type: String,
      required: !0
    }
  },
  emits: ["submit", "update:modelValue"],
  setup(K, { emit: N }) {
    const e = K;
    q(
      () => e.modelValue,
      (t) => {
        t && (a.value = t, F(() => {
          R();
        }));
      }
    );
    const a = s(!1), h = N, B = () => {
      h("update:modelValue", !1);
    }, _ = s([]), C = j(() => {
      let t = E(e.data);
      for (let l of t)
        _.value.push(l[e.selectKey]);
      return t;
    });
    function E(t) {
      let l = JSON.parse(JSON.stringify(t));
      return l.filter((n) => {
        let u = l.filter(
          (m) => n[e.selectKey] == m[e.parentSelectKey]
        );
        return u.length > 0 && (n.children = u), !n[e.parentSelectKey];
      });
    }
    const i = s();
    function D() {
      let t = [];
      e.selectType == "checkbox" ? t = i.value.getCheckedNodes() : t = k.value, h("submit", t), a.value = !1;
    }
    function R() {
      if (e.selectValue.length > 0)
        if (e.selectType == "checkbox")
          i.value.setCheckedKeys(e.selectValue);
        else {
          let t = i.value.getNode(e.selectValue);
          b(t.data);
        }
    }
    const d = s(!1), k = s({});
    function b(t) {
      k.value = t, d.value = t[e.selectKey];
    }
    return (t, l) => {
      const n = A, u = M, m = z, x = G, O = H;
      return y(), J(O, {
        modelValue: p(a),
        "onUpdate:modelValue": l[2] || (l[2] = (r) => v(a) ? a.value = r : null),
        title: e.title || "新增/修改模型",
        onClose: B,
        "destroy-on-close": "",
        draggable: "",
        "append-to-body": "",
        "close-on-click-modal": !1,
        "close-on-press-escape": !1,
        width: e.width,
        "custom-class": e.class + " tree-dialog"
      }, {
        footer: o(() => [
          T("span", L, [
            c(x, {
              onClick: l[1] || (l[1] = (r) => a.value = !1)
            }, {
              default: o(() => [
                g(f(e.cancelButtonText), 1)
              ]),
              _: 1
            }),
            c(x, {
              type: "primary",
              onClick: D
            }, {
              default: o(() => [
                g(f(e.submitButtonText), 1)
              ]),
              _: 1
            })
          ])
        ]),
        default: o(() => [
          c(m, null, {
            default: o(() => [
              c(u, {
                data: p(C),
                "node-key": e.selectKey,
                "highlight-current": "",
                "default-expanded-keys": p(_),
                "show-checkbox": e.selectType == "checkbox",
                props: {
                  children: "children",
                  label: e.showFieldName
                },
                ref_key: "treeRef",
                ref: i
              }, {
                default: o(({ node: r, data: V }) => [
                  e.selectType == "radio" ? (y(), w(U, { key: 0 }, [
                    c(n, {
                      label: V[e.selectKey],
                      modelValue: p(d),
                      "onUpdate:modelValue": l[0] || (l[0] = (S) => v(d) ? d.value = S : null),
                      onClick: $((S) => b(V), ["stop"])
                    }, {
                      default: o(() => [
                        g(" ")
                      ]),
                      _: 2
                    }, 1032, ["label", "modelValue", "onClick"]),
                    T("span", null, f(r.label), 1)
                  ], 64)) : (y(), w("span", I, f(r.label), 1))
                ]),
                _: 1
              }, 8, ["data", "node-key", "default-expanded-keys", "show-checkbox", "props"])
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["modelValue", "title", "width", "custom-class"]);
    };
  }
};
export {
  ie as default
};
