import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-cascader.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-popper.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-tag.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-cascader-panel.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-checkbox.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-radio.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import { inject as y, ref as p, computed as N, watch as b, nextTick as P, openBlock as x, createElementBlock as S, Fragment as T, unref as n, createBlock as q, mergeProps as B, isRef as F, toHandlers as J, createCommentVNode as U, createElementVNode as H, toDisplayString as M } from "vue";
import A from "../../../utils/formUtil.js";
import { getLibraryOptionData4Cascader as C } from "../../../utils/libraryUtil.js";
import { getPlaceholder as R } from "../../../utils/i18nUtil.js";
import { ElCascader as G } from "../../../../../node_modules/element-plus/es/components/cascader/index.js";
const K = { class: "layout layout-form-text" }, pe = {
  __name: "Cascader",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    query: String,
    event: Object,
    modelValue: Array,
    pramDicItem: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["update:modelValue"],
  setup(V, { emit: _ }) {
    const c = y("formData");
    y("isLayout");
    const v = y("changeFieldData"), d = p(), t = V, j = _, u = N({
      get: () => t.modelValue,
      set: (e) => {
        j("update:modelValue", e);
      }
    }), I = N(() => !!(t.option.disabled || t.option.readOnly));
    function w(e) {
      let r = d.value.getCheckedNodes(), a = [];
      r.forEach((i) => {
        let l;
        if (t.option.showAll) {
          let o = t.option.separator || "/";
          l = i.pathLabels.join(o);
        } else {
          let o = i.pathLabels;
          l = o[o.length - 1];
        }
        a.push(l);
      }), c.value[t.option.fieldDesc] = a.join("|"), v && v(t.option.fieldName, e);
    }
    const m = p([]);
    function z(e) {
      C(
        c.value,
        t.option,
        e,
        m
      );
    }
    const g = p(), f = p(""), D = p(!0);
    b(m, (e) => {
      g.value = E(e), t.query == "query" && P(() => {
        let r = d.value.getCheckedNodes(), a = [];
        r.forEach((i) => {
          let l;
          if (t.option.showAll) {
            let o = t.option.separator || "/";
            l = i.pathLabels.join(" " + o + " ");
          } else {
            let o = i.pathLabels;
            l = o[o.length - 1];
          }
          a.push(l);
        }), f.value = a.join(" | ");
      });
    }), b(f, (e) => {
      e && (D.value = !1);
    });
    const s = p();
    b(
      () => t.option,
      (e) => {
        if (e.optionType === "2" && t.pramDicItem) {
          s.value = {
            value: "optCode",
            label: "optName"
          };
          let r = A.clone(t.pramDicItem);
          r.forEach((a) => {
            a.id = a.dicPkId, a.pid = a.ppkId;
          }), m.value = r;
        } else
          e.optionType === "3" && (s.value = {
            value: "optCode",
            label: "optName",
            multiple: e.multiple == !0,
            lazy: !!e.lazyLoad,
            checkStrictly: !!e.checkArbitrarily,
            /* 级联数据懒加载 */
            lazyLoad(r, a) {
              let i = r.data.id || "", o = {
                [e.library.parentPrimaryId]: i
              };
              o.isLazy = !0, C(
                c.value,
                e,
                o,
                null,
                (k) => {
                  a(k);
                }
              );
            }
          }, s.value.lazy || z({ isLazy: !1 }));
      },
      {
        deep: !0,
        immediate: !0
      }
    );
    function E(e) {
      let r = JSON.parse(JSON.stringify(e)), a = r.filter((l) => {
        let o = r.filter((h) => l.id == h.pid);
        return l.leaf = !0, o.length > 0 && (l.children = o, l.leaf = !1), !r.find((h) => l.pid == h.id);
      }), i = t.option.maxLvl;
      return a = L(a, i), a;
    }
    function L(e, r = 10) {
      return e ? e.map((a) => {
        let i = r <= 1 ? [] : L(a.children, r - 1), l = !1;
        return i.length == 0 && (l = !0), {
          ...a,
          children: i,
          leaf: l
        };
      }) : [];
    }
    function O(e, r) {
      return e.pathLabels.join(",").indexOf(r) != -1;
    }
    return (e, r) => {
      const a = G;
      return x(), S(T, null, [
        n(D) ? (x(), q(a, B({
          key: 0,
          modelValue: n(u),
          "onUpdate:modelValue": r[0] || (r[0] = (i) => F(u) ? u.value = i : null),
          options: n(g),
          ref_key: "cascader",
          ref: d,
          clearable: "",
          filterable: !t.option.lazyLoad,
          "filter-method": O,
          props: n(s),
          placeholder: n(R)(t.option),
          disabled: n(I)
        }, J(t.event), {
          separator: n(A).isEmpty(t.option.separator) ? "/" : t.option.separator,
          "show-all-levels": t.option.showAll,
          onChange: w
        }), null, 16, ["modelValue", "options", "filterable", "props", "placeholder", "disabled", "separator", "show-all-levels"])) : U("", !0),
        H("div", K, M(n(f)), 1)
      ], 64);
    };
  }
};
export {
  pe as default
};
