import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-form.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-table.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-checkbox.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-tooltip.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-popper.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-table-column.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-tag.css.js";
import { ref as o, getCurrentInstance as ne, computed as B, provide as f, watch as P, nextTick as q, openBlock as C, createBlock as O, normalizeClass as H, withCtx as x, createVNode as K, createElementBlock as ie, Fragment as me, renderList as se, unref as J, renderSlot as ue, createCommentVNode as fe } from "vue";
import g from "../../../utils/formUtil.js";
import { initOption as ce, initFormData as U, initState as de, initTableData as pe, initEvent as z, initRule as L, changeState as ve } from "./form.js";
import { getFormValue as M } from "./interface/getFormValue.js";
import { setFormValue as De, setFormValueByFieldName as ye } from "./interface/setFormValue.js";
import { validateForm as Fe } from "./interface/validateForm.js";
import { clearValidate as we } from "./interface/clearValidate.js";
import { formItem as xe } from "../formItem/index.js";
import { ElTableColumn as ge, ElTable as be } from "../../../../../node_modules/element-plus/es/components/table/index.js";
import { ElForm as Ie } from "../../../../../node_modules/element-plus/es/components/form/index.js";
const Qe = {
  __name: "Form",
  props: {
    formId: {
      type: String,
      required: !0
    },
    isDisabled: {
      type: Boolean,
      default: !1
    },
    initFormData: {
      type: Object,
      default: {}
    }
  },
  emits: ["onCreated"],
  setup(b, { expose: G, emit: Q }) {
    const D = o(null);
    o();
    const y = b;
    let c = ne().proxy.$parent;
    const I = o(!1);
    let m = {};
    const u = o({});
    let N = {};
    const S = o("");
    let V = {}, F = [], T = {};
    const l = o(), k = o(), _ = o(), w = o(), r = o({}), d = o({}), W = o({}), X = Q;
    ce(y, (e) => {
      d.value = e, m = g.clone(e), l.value = m.formItem, u.value = m.init.pramDicItem, N = m.init.dicKeyData, S.value = m.init.formClass, V = de(m), F = Object.keys(V), T = pe(l), r.value = U(l.value, y.initFormData), _.value = z(l.value, c), w.value = L(l.value, c, r), p(), I.value = !0, q(() => {
        X("onCreated");
      });
    });
    const Y = B(() => {
      let e = [];
      for (let t = 0; t < m.columns; t++) {
        let a = t + "";
        e.push({ index: a });
      }
      return e;
    });
    function Z(e, t) {
      F.indexOf(e) != -1 && p();
    }
    f("changeFieldData", Z);
    function p() {
      let e = M(l.value, r.value);
      const t = ve(
        u.value,
        N,
        l.value,
        T,
        V,
        e,
        r
      );
      k.value = t, _.value = z(l.value, c), w.value = L(l.value, c, r);
    }
    P(
      () => y.initFormData,
      (e) => {
        I.value && (r.value = U(l.value, e), E.value = "", p());
      },
      {
        deep: !0
      }
    ), P(w, (e, t) => {
      if (t)
        for (let a in e)
          JSON.stringify(e[a]) != JSON.stringify(t[a]) && q(() => {
            $(a);
          });
    }), f(
      "formData",
      B(() => r.value)
    ), f("parentVm", c);
    const E = o("");
    f("currentEditFieldName", E), f("formItemOption", l);
    const A = ({ row: e, column: t, rowIndex: a, columnIndex: n }) => {
      let v = e[n + ""];
      return v && [v.rowspan, v.colspan];
    }, j = (e) => {
      let t = e.row;
      for (let a in t)
        if (t[a].fieldType != "empty")
          return null;
      return { display: "none" };
    }, ee = (e) => {
      let t = e.row;
      for (let a in t)
        if (t[a].fieldType == "label")
          return "label";
      return "";
    };
    function te(e) {
      if (e.row[e.columnIndex] && e.row[e.columnIndex].fieldType == "empty" && e.row[e.columnIndex + 1] && e.row[e.columnIndex + 1].fieldType == "empty")
        return "is-empty";
    }
    let R = {};
    const ae = (e) => {
      if (e) {
        const t = e.getFormItem();
        R[t.fieldName] = t.ref;
      }
    };
    function h(e) {
      const t = M(l.value, r.value, e);
      return e ? t[e] : t;
    }
    f("getFormValue", h);
    const le = (e, t) => {
      if (typeof e == "object") {
        De(l.value, r, e);
        let a = !1;
        for (let n in e)
          if (F.indexOf(n) != -1) {
            a = !0;
            break;
          }
        a && p();
      } else
        typeof e == "string" && typeof t < "u" && (ye(
          l.value,
          r,
          e,
          t
        ), F.indexOf(e) != -1 && p());
    }, re = (e, t) => {
      Fe(D, (a, n) => {
        a ? g.isFunction(e) && e(h()) : g.isFunction(t) && t(n);
      });
    }, $ = (e, t) => {
      we(D, e, () => {
        g.isFunction(t) && t();
      });
    };
    return G({
      getFormValue: h,
      setFormValue: le,
      validateForm: re,
      clearValidate: $,
      resetFields: () => {
        D.value.resetFields();
      },
      getFormItem: (e) => R[e],
      getParmDic: (e) => e ? u.value[e] : u.value,
      setParmDic: (e, t) => {
        t && t.length > 0 && (u.value[e] = t);
      }
      // /** @description validate form */
      // validate,
      // /** @description validate form field */
      // validateField,
      // /** @description reset fields */
      // resetFields,
      // /** @description clear validation status */
      // clearValidate,
      // /** @description scroll to field */
      // scrollToField,
    }), (e, t) => {
      const a = ge, n = be, v = Ie;
      return I.value ? (C(), O(v, {
        key: 0,
        "data-id": y.formId,
        "label-position": d.value.labelPosition,
        model: r.value,
        rules: w.value,
        ref_key: "formRef",
        ref: D,
        disabled: !!(d.value.formDisabled || b.isDisabled),
        "label-width": "160px",
        class: H(S.value),
        "validate-on-rule-change": !1,
        "scroll-to-error": ""
      }, {
        default: x(() => [
          K(n, {
            noScrollbar: !0,
            data: k.value,
            "show-header": !1,
            "span-method": A,
            "row-style": j,
            "row-class-name": ee,
            "cell-class-name": te,
            ref_key: "tableRef",
            ref: W,
            "empty-text": " ",
            class: H(d.value.formDisabled || b.isDisabled ? "is-disabled" : "")
          }, {
            default: x(() => [
              (C(!0), ie(me, null, se(J(Y), (i) => (C(), O(a, {
                key: i.index,
                prop: i.index
              }, {
                default: x((s) => [
                  K(J(xe), {
                    option: s.row[i.index],
                    modelValue: r.value,
                    "onUpdate:modelValue": t[0] || (t[0] = (oe) => r.value = oe),
                    event: s.row[i.index] && _.value[s.row[i.index].fieldName],
                    pramDicItem: s.row[i.index] && u.value[s.row[i.index].fieldName],
                    query: d.value.query,
                    ref_for: !0,
                    ref: ae
                  }, {
                    default: x(() => [
                      ue(e.$slots, s.row[i.index] && s.row[i.index].fieldName, { formData: r.value })
                    ]),
                    _: 2
                  }, 1032, ["option", "modelValue", "event", "pramDicItem", "query"])
                ]),
                _: 2
              }, 1032, ["prop"]))), 128))
            ]),
            _: 3
          }, 8, ["data", "class"])
        ]),
        _: 3
      }, 8, ["data-id", "label-position", "model", "rules", "disabled", "class"])) : fe("", !0);
    };
  }
};
export {
  Qe as default
};
