import "../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-form.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-pagination.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-tag.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-option.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-option-group.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-popper.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-select.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-table.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-checkbox.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-tooltip.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-button-group.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-dropdown.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-dropdown-menu.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-dropdown-item.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-icon.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-radio.css.js";
import "../../../../node_modules/element-plus/theme-chalk/el-table-column.css.js";
import { ref, getCurrentInstance, shallowRef, provide, watch, nextTick, onUnmounted, resolveComponent, resolveDirective, openBlock, createElementBlock, createBlock, resolveDynamicComponent, unref, withCtx, createVNode, isRef, createTextVNode, createCommentVNode, Fragment, renderList, withDirectives, renderSlot, withModifiers, toDisplayString, createElementVNode } from "vue";
import store from "../../store/index.js";
import { initOption, initEditTable, setLazyTreeNodeMap, initSelectionRows, initTableData, initPagination, initOptBtnsCol, initPramDicItem, initEvent, initRule, initTableQueryModel, initTableHeight, editTableCell, tableFormatter, getSummaries, treeLoads, editTableRow, getEditTableData } from "./table.js";
import formUtil from "../../utils/formUtil.js";
import { getLabelContent } from "../../utils/i18nUtil.js";
import _sfc_main$1 from "./TableItem.vue.js";
import { useRoute } from "vue-router";
import "./Table.vue2.js";
import { ElTableColumn, ElTable } from "../../../../node_modules/element-plus/es/components/table/index.js";
import { ElRadio } from "../../../../node_modules/element-plus/es/components/radio/index.js";
import { ElButton } from "../../../../node_modules/element-plus/es/components/button/index.js";
import { ElIcon } from "../../../../node_modules/element-plus/es/components/icon/index.js";
import { ElDropdownItem, ElDropdownMenu, ElDropdown } from "../../../../node_modules/element-plus/es/components/dropdown/index.js";
import { ElPagination } from "../../../../node_modules/element-plus/es/components/pagination/index.js";
import { ElForm } from "../../../../node_modules/element-plus/es/components/form/index.js";
const _hoisted_1 = { class: "h-table" }, _hoisted_2 = { class: "el-pagination_slot" }, _sfc_main = {
  __name: "Table",
  props: {
    tableId: {
      type: String,
      required: !0
    },
    tableData: {
      type: Object,
      default: []
    },
    initOption: {
      type: Object,
      default: {}
    },
    query: {
      type: Boolean,
      default: !1
    },
    initSearchData: {
      type: Object,
      default: {}
    }
  },
  setup(__props, { expose: __expose }) {
    const route = useRoute(), tableRef = ref(null), props = __props;
    let parentVm = getCurrentInstance().proxy.$parent;
    const show = ref(!1);
    let option = {};
    const optionRef = ref();
    let tableId = props.tableId, tableName = ref("");
    const tableData = ref(props.tableData), tableDataResult = ref({}), pramDicItem = ref({}), events = ref({}), rules = ref([]), tableHeight = ref({});
    let queryModel = shallowRef(null);
    const pagination = ref(), optBtnsCol = ref(), sessionPageData = ref(), queryModelRef = ref();
    let editTableData = [];
    const tableFormRef = ref(), formData = ref({});
    provide("formData", formData), provide("query", props.query), initOption(props, (e) => {
      optionRef.value = e, option = formUtil.clone(e), tableName.value = option.tableName, pagination.value = initPagination(option), optBtnsCol.value = initOptBtnsCol(option), initPramDicItem(option, pramDicItem), option.isEdit && (initEvent(option, events, parentVm), initRule(option, rules, parentVm));
      let t = sessionStorage.getItem(tableId);
      t != null ? (t = JSON.parse(t), pagination.value.pageNo = t.pageNo, pagination.value.pageSize = t.pageSize, sessionPageData.value = t) : t = {}, queryModel.value = initTableQueryModel(option), option.isTree && (t.treeKeyValue = 0), getTableData(pagination.value.pageSize, pagination.value.pageNo, t), show.value = !0, nextTick(() => {
        tableHeight.value = initTableHeight(
          tableRef,
          option,
          pagination.value.show
        );
      });
    });
    function getTableData(e, t, o) {
      nextTick(() => {
        let a = "", n = "";
        queryModelRef.value && (a = queryModelRef.value.getCurrTabQuery ? queryModelRef.value.getCurrTabQuery() : "", n = queryModelRef.value.getDynamicQuery ? queryModelRef.value.getDynamicQuery() : "");
        const r = {
          pageSize: e,
          pageNo: t,
          tableId,
          queryTab: a,
          dynamicQuery: n
        };
        Object.assign(r, props.initSearchData), o && Object.assign(r, o), sessionStorage.setItem(tableId, JSON.stringify(r)), initTableData(option, r, tableDataResult);
      });
    }
    watch(tableDataResult, (e) => {
      option.pageInfoClass === "unIsPagination" ? pagination.value.pageSize = 0 : pagination.value.pageSize = e.pageSize, pagination.value.pageNo = e.pageNo, pagination.value.pageTotal = e.pageTotal, tableData.value = [], tableRef.value.store.states.lazyTreeNodeMap.value = {}, nextTick(() => {
        tableData.value = e.tableData, editTableData = formUtil.clone(tableData.value), option.editType == "always" && option.isEdit && initEditTable(tableData, option), option.isTree && setLazyTreeNodeMap(tableRef, tableData.value, option), initSelectionRows(tableRef, selectionRows, option, tableData);
      });
    });
    const isTableBtn = ref(!1);
    onUnmounted(() => {
      isTableBtn.value || (sessionStorage.removeItem(tableId), isTableBtn.value = !1);
    });
    function executeEvent(e, t, o) {
      const a = formUtil.parentVmExist(parentVm, e);
      a && (isTableBtn.value = !0, a[e](t, o));
    }
    function setIsTableBtn(e) {
      isTableBtn.value = e;
    }
    function customBtnEvent(e, t, o) {
      const a = formUtil.parentVmExist(parentVm, e);
      a && a[e](t, o);
    }
    function handleSizeChange(e) {
      let t = getSessionStorageSearchData();
      getTableData(e, 1, t);
    }
    function handleCurrentChange(e) {
      if (typeof pagination.value.pageSize < "u") {
        let t = getSessionStorageSearchData();
        getTableData(pagination.value.pageSize, e, t);
      }
    }
    function getSessionStorageSearchData() {
      let e = sessionStorage.getItem(tableId);
      return e != null && (e = JSON.parse(e), delete e.pageNo, delete e.pageSize), e;
    }
    let templateSelection = null;
    const templateRadio = ref(!1);
    function currentChange(e, t) {
      if (templateSelection = e, !(!e || !option.isInDialog)) {
        if (option.isSelect)
          tableRef.value.toggleRowSelection(e);
        else if (option.isRadio) {
          for (let o in tableData.value)
            if (tableData.value[o][option.pkey] == e[option.pkey]) {
              templateRadio.value = Number(o);
              break;
            }
        }
      }
    }
    function rowClick(e, t, o) {
      let a = option.oneFunc;
      const n = formUtil.parentVmExist(parentVm, a);
      option.oneClickEve && n && n[a](e);
    }
    function rowDblClick(e, t, o) {
      let a = option.doubleFunc;
      const n = formUtil.parentVmExist(parentVm, a);
      option.doubleClickEve && n && n[a](e);
    }
    function cellDblclick(e, t, o, a) {
      if (option.isEdit && option.dblEdit) {
        let n = a.currentTarget.rowIndex;
        option.dblEditType == "row" ? editTableRow$1(n, !0) : option.dblEditType == "cell" && editTableCell(e, n, t.property), document.onclick = function() {
          const r = formUtil.parentVmExist(
            parentVm,
            option.dblEditCallback
          );
          if (r)
            r[option.dblEditCallback](e, (s) => {
              s && (option.dblEditType == "row" ? delete e.isRowEdit : option.dblEditType == "cell" && (delete e.editRowIndex, delete e.editFieldName));
            });
          else if (option.dblEditType == "row")
            editTableRow$1(n, !1);
          else if (option.dblEditType == "cell") {
            let s = editTableData[n];
            tableData.value[n][t.property] = formUtil.clone(
              s[t.property]
            ), delete e.editRowIndex, delete e.editFieldName;
          }
          document.onclick = null;
        };
      }
    }
    function rowStyle(e) {
      let t = option["row-style"];
      if (Object.prototype.toString.call(t) === "[object Object]")
        return t;
      if (t) {
        const o = formUtil.parentVmExist(parentVm, t);
        if (o)
          return o[t](e);
      }
    }
    function rowClassName(e) {
      let t = option["row-class-name"];
      if (t) {
        const o = formUtil.parentVmExist(parentVm, t);
        if (o)
          return o[t](e);
      } else
        return t;
    }
    function cellStyle(e) {
      let t = option["cell-style"];
      if (Object.prototype.toString.call(t) === "[object Object]")
        return t;
      if (t) {
        const o = formUtil.parentVmExist(parentVm, t);
        if (o)
          return o[t](e);
      }
    }
    function cellClassName(e) {
      let t = "", o = option.columns.find((n) => {
        if (e.column.property == n.fieldName)
          return !0;
      });
      if (o && o.converColorData && o.converColorData.length > 0) {
        let n = e.row[o.fieldName] || "";
        for (let r of o.converColorData)
          if (r.originalData == n) {
            t += " " + r.dataColor;
            break;
          }
      }
      let a = option["cell-class-name"];
      if (a) {
        const n = formUtil.parentVmExist(parentVm, a);
        if (n)
          return t + " " + n[a](e);
      } else
        return t + " " + a;
    }
    function noShowParams(btn, row) {
      if (JSON.stringify(row) == "{}")
        return !1;
      let buttonAuth = !1, auth = btn.noShowParams || "";
      if (auth.indexOf("-") != -1) {
        let e = auth.split(";");
        for (let t in e)
          if (!formUtil.isEmpty(e[t])) {
            let o = e[t].split("-");
            if (o.length === 2) {
              let a = formUtil.parsFieldName(o[1], row, route);
              row[o[0]] == a && (buttonAuth = !0);
            }
            if (!buttonAuth && (o = e[t].split("!-"), o.length === 2)) {
              let a = formUtil.parsFieldName(o[1], row, route);
              row[o[0]] != a && (buttonAuth = !0);
            }
          }
        return buttonAuth;
      } else {
        let keys = formUtil.doExpression(auth), buttonAuthObj = store.getters.buttonAuth || {};
        for (let e of keys.values()) {
          let t = row[e];
          t || buttonAuthObj[e] && (t = buttonAuthObj[e]), /* formUtil.isNumber(value) || */
          t === !0 || t === !1 || t === "true" || t === "false" ? auth = auth.replaceAll("${" + e + "}", t) : auth = auth.replaceAll("${" + e + "}", `'${t}'`);
        }
        return !!eval(auth);
      }
    }
    function tableFormatter$1(e, t) {
      return tableFormatter(e, t, pramDicItem[t.fieldName]);
    }
    function moreBtnhandleCommand(e) {
      let t = e.index, o = e.row, a = e.callback;
      executeEvent(a, o, t);
    }
    function getSummaries$1(e) {
      return getSummaries(option, e, tableId, option.summationType);
    }
    function treeLoads$1(e, t, o) {
      t.expanded ? (o(e.children), tableRef.value.toggleRowExpansion(e, !1)) : treeLoads(e, t, o, option, tableId);
    }
    const editTableRow$1 = (e, t) => {
      if (e != null)
        if (t) {
          let o = tableData.value[e];
          editTableRow(o, option);
        } else {
          let o = editTableData[e];
          tableData.value[e] = formUtil.clone(o);
        }
      else
        t ? initEditTable(tableData, option) : tableData.value = formUtil.clone(editTableData);
    };
    function addTableRow() {
      let e = { isRowEdit: !0, isNewRow: !0 };
      option.columns.forEach((t) => {
        t.fieldName && (e[t.fieldName] = "");
      }), tableData.value.push(e), nextTick(() => {
        tableRef.value.setScrollTop(tableRef.value.scrollBarRef.$el.scrollHeight);
      });
    }
    function delTableRow(e) {
      tableData.value.splice(e, 1);
    }
    function tableSelected(e, t) {
      let o = !1;
      for (let n of e)
        if (formUtil.isObjEqual(n, t)) {
          o = !0;
          break;
        }
      const a = formUtil.parentVmExist(parentVm, option.selectedEvent);
      a && a[option.selectedEvent](t, o);
    }
    function tableSelectedAll(e) {
      const t = formUtil.parentVmExist(parentVm, option.selectedAllEvent);
      t && t[option.selectedAllEvent](e);
    }
    function getRowKey() {
      return optionRef.value.treeKey ? optionRef.value.treeKey : optionRef.value.selectKey ? optionRef.value.selectKey : "opNo";
    }
    const getEditData = () => getEditTableData(tableData, editTableData, option), addRow = () => {
      addTableRow();
    }, delRow = (e) => {
      delTableRow(e);
    }, editRow = (e) => {
      editTableRow$1(e, !0);
    }, cancelEditRow = (e) => {
      editTableRow$1(e, !1);
    }, editAll = () => {
      editTableRow$1(null, !0);
    }, cancelEditAll = () => {
      editTableRow$1(null, !1);
    }, refresh = () => {
      nextTick(() => {
        let e = getSessionStorageSearchData();
        Object.assign(e, props.initSearchData), getTableData(
          pagination.value.pageSize,
          pagination.value.pageNo,
          e
        );
      });
    }, getData = () => tableData.value, validateTable = (e, t) => {
      tableFormRef.value.validate((o, a) => {
        o ? formUtil.isFunction(e) && e() : formUtil.isFunction(t) && t(a);
      });
    }, search = (e) => {
      let t = queryModelRef.value.getCurrTabQuery ? queryModelRef.value.getCurrTabQuery() : "", o = queryModelRef.value.getDynamicQuery ? queryModelRef.value.getDynamicQuery() : "";
      const a = {
        queryTab: t,
        dynamicQuery: o
      };
      e ? Object.assign(a, e) : !t && !o && option.isTree && (a.treeKeyValue = 0), getTableData(pagination.value.pageSize, 1, a);
    }, getSelectionRows = () => {
      if (option.isSelect) {
        const e = tableRef.value.getSelectionRows();
        return formUtil.clone(e);
      } else
        return formUtil.clone(templateSelection);
    };
    let selectionRows = null;
    const setSelectionRows = (e) => {
      !e || e.length == 0 ? tableRef.value.clearSelection() : (selectionRows = e, initSelectionRows(tableRef, e, option, tableData));
    };
    return __expose({
      refresh,
      search,
      getSelectionRows,
      setSelectionRows,
      addRow,
      delRow,
      editRow,
      cancelEditRow,
      editAll,
      cancelEditAll,
      getEditData,
      getData,
      validateTable
      // setTableData,
    }), provide("customBtnEvent", customBtnEvent), provide("searchTable", search), provide("initTableData", initTableData), provide("initSearchData", props.initSearchData), provide("tableFormatter", tableFormatter$1), provide("tableId", tableId), provide("tableName", tableName), (e, t) => {
      const o = ElTableColumn, a = ElRadio, n = ElButton, r = resolveComponent("ArrowDownBold"), s = ElIcon, c = ElDropdownItem, m = ElDropdownMenu, f = ElDropdown, d = ElTable, b = ElPagination, g = ElForm, p = resolveDirective("auth");
      return openBlock(), createElementBlock("div", _hoisted_1, [
        (openBlock(), createBlock(resolveDynamicComponent(unref(queryModel)), {
          option: unref(optionRef),
          pramDicItem: unref(pramDicItem),
          sessionPageData: unref(sessionPageData),
          query: __props.query,
          ref_key: "queryModelRef",
          ref: queryModelRef
        }, null, 8, ["option", "pramDicItem", "sessionPageData", "query"])),
        unref(show) ? (openBlock(), createBlock(g, {
          key: 0,
          ref_key: "tableFormRef",
          ref: tableFormRef,
          style: { width: "100%", "flex-grow": "1" },
          class: "h-table-form",
          model: { tableData: unref(tableData) },
          rules: unref(rules)
        }, {
          default: withCtx(() => [
            createVNode(d, {
              "data-id": props.tableId,
              data: unref(tableData),
              "highlight-current-row": "",
              stripe: "",
              border: "",
              ref_key: "tableRef",
              ref: tableRef,
              "show-summary": unref(optionRef).summation,
              "summary-method": getSummaries$1,
              height: unref(tableHeight).height,
              "max-height": unref(tableHeight).maxHeight,
              "row-key": getRowKey(),
              "tree-props": { children: "children", hasChildren: "hasChildren" },
              lazy: "",
              load: treeLoads$1,
              "row-style": rowStyle,
              "row-class-name": rowClassName,
              "cell-style": cellStyle,
              "cell-class-name": cellClassName,
              onRowDblclick: rowDblClick,
              onRowClick: rowClick,
              onCellDblclick: cellDblclick,
              onCurrentChange: currentChange,
              onSelect: tableSelected,
              onSelectAll: tableSelectedAll
            }, {
              default: withCtx(() => [
                !__props.query && unref(optionRef).isSelect ? (openBlock(), createBlock(o, {
                  key: 0,
                  type: "selection",
                  fixed: "",
                  width: "50",
                  align: "center",
                  "reserve-selection": !0
                })) : unref(optionRef).isRadio ? (openBlock(), createBlock(o, {
                  key: 1,
                  fixed: "",
                  label: "",
                  width: "50",
                  align: "center",
                  "header-align": "center",
                  "class-name": "el-table-column--selection"
                }, {
                  default: withCtx((l) => [
                    createVNode(a, {
                      label: l.$index,
                      modelValue: unref(templateRadio),
                      "onUpdate:modelValue": t[0] || (t[0] = (i) => isRef(templateRadio) ? templateRadio.value = i : null),
                      style: { "margin-left": "10px" }
                    }, {
                      default: withCtx(() => [
                        createTextVNode(" ")
                      ]),
                      _: 2
                    }, 1032, ["label", "modelValue"])
                  ]),
                  _: 1
                })) : createCommentVNode("", !0),
                unref(optionRef).isSerial ? (openBlock(), createBlock(o, {
                  key: 2,
                  type: "index",
                  fixed: "",
                  width: "65",
                  align: "center"
                }, {
                  header: withCtx(() => [
                    createTextVNode("序号")
                  ]),
                  _: 1
                })) : createCommentVNode("", !0),
                (openBlock(!0), createElementBlock(Fragment, null, renderList(unref(optionRef).columns, (l) => (openBlock(), createElementBlock(Fragment, {
                  key: l.fieldName
                }, [
                  l.fieldName != "" && l.isShow ? withDirectives((openBlock(), createBlock(o, {
                    key: 0,
                    prop: l.fieldName,
                    label: unref(getLabelContent)(l),
                    "show-overflow-tooltip": l["show-overflow-tooltip"] === !0,
                    "min-width": l.minWidth,
                    fixed: l.fixedColumn || !1,
                    align: l.align || "left",
                    "header-align": l.align || "left",
                    width: l.width,
                    sortable: l.sortType == "defaultSort"
                  }, {
                    default: withCtx((i) => [
                      createVNode(_sfc_main$1, {
                        col: l,
                        scope: i,
                        rules: unref(rules),
                        pramDicItem: unref(pramDicItem),
                        events: unref(events),
                        parentVm: unref(parentVm),
                        query: __props.query,
                        onSetIsTableBtn: setIsTableBtn
                      }, {
                        default: withCtx(() => [
                          renderSlot(e.$slots, l.fieldName, {
                            row: i.row,
                            column: i.column,
                            $index: i.$index
                          })
                        ]),
                        _: 2
                      }, 1032, ["col", "scope", "rules", "pramDicItem", "events", "parentVm", "query"])
                    ]),
                    _: 2
                  }, 1032, ["prop", "label", "show-overflow-tooltip", "min-width", "fixed", "align", "header-align", "width", "sortable"])), [
                    [p, l.perm]
                  ]) : createCommentVNode("", !0)
                ], 64))), 128)),
                unref(optBtnsCol).show && !__props.query ? (openBlock(), createBlock(o, {
                  key: 3,
                  fixed: "right",
                  label: "操作",
                  align: "center",
                  width: unref(optBtnsCol).width,
                  "min-width": unref(optBtnsCol).minWidth
                }, {
                  default: withCtx((l) => [
                    unref(optBtnsCol).moreBtnCut == 0 ? (openBlock(!0), createElementBlock(Fragment, { key: 0 }, renderList(unref(optBtnsCol).data, (i) => withDirectives((openBlock(), createBlock(n, {
                      key: i.id,
                      disabled: noShowParams(i, l.row),
                      link: "",
                      type: "primary",
                      onClick: withModifiers((u) => executeEvent(i.callback, l.row, l.$index), ["stop"])
                    }, {
                      default: withCtx(() => [
                        createTextVNode(toDisplayString(unref(getLabelContent)(i)), 1)
                      ]),
                      _: 2
                    }, 1032, ["disabled", "onClick"])), [
                      [p, i.perm]
                    ])), 128)) : (openBlock(), createElementBlock(Fragment, { key: 1 }, [
                      (openBlock(!0), createElementBlock(Fragment, null, renderList(unref(optBtnsCol).data, (i, u) => (openBlock(), createElementBlock(Fragment, {
                        key: i.id
                      }, [
                        u + 1 <= unref(optBtnsCol).moreBtnCut ? withDirectives((openBlock(), createBlock(n, {
                          key: 0,
                          disabled: noShowParams(i, l.row),
                          link: "",
                          type: "primary",
                          onClick: withModifiers((w) => executeEvent(i.callback, l.row, l.$index), ["stop"])
                        }, {
                          default: withCtx(() => [
                            createTextVNode(toDisplayString(unref(getLabelContent)(i)), 1)
                          ]),
                          _: 2
                        }, 1032, ["disabled", "onClick"])), [
                          [p, i.perm]
                        ]) : createCommentVNode("", !0)
                      ], 64))), 128)),
                      createVNode(f, {
                        trigger: "click",
                        onCommand: moreBtnhandleCommand,
                        size: "mini",
                        placement: "bottom",
                        class: "moreBtn"
                      }, {
                        dropdown: withCtx(() => [
                          createVNode(m, null, {
                            default: withCtx(() => [
                              (openBlock(!0), createElementBlock(Fragment, null, renderList(unref(optBtnsCol).data, (i, u) => (openBlock(), createElementBlock(Fragment, {
                                key: i.id
                              }, [
                                u + 1 > unref(optBtnsCol).moreBtnCut ? withDirectives((openBlock(), createBlock(c, {
                                  key: 0,
                                  disabled: noShowParams(i, l.row),
                                  command: {
                                    callback: i.callback,
                                    index: l.$index,
                                    row: l.row
                                  }
                                }, {
                                  default: withCtx(() => [
                                    createTextVNode(toDisplayString(unref(getLabelContent)(i)), 1)
                                  ]),
                                  _: 2
                                }, 1032, ["disabled", "command"])), [
                                  [p, i.perm]
                                ]) : createCommentVNode("", !0)
                              ], 64))), 128))
                            ]),
                            _: 2
                          }, 1024)
                        ]),
                        default: withCtx(() => [
                          createVNode(s, null, {
                            default: withCtx(() => [
                              createVNode(r)
                            ]),
                            _: 1
                          })
                        ]),
                        _: 2
                      }, 1024)
                    ], 64))
                  ]),
                  _: 1
                }, 8, ["width", "min-width"])) : createCommentVNode("", !0)
              ]),
              _: 3
            }, 8, ["data-id", "data", "show-summary", "height", "max-height", "row-key"]),
            unref(pagination).show ? (openBlock(), createBlock(b, {
              key: 0,
              background: "",
              "hide-on-single-page": !unref(option).isNoDataPagination,
              onSizeChange: handleSizeChange,
              onCurrentChange: handleCurrentChange,
              "page-sizes": [10, 20, 50, 100],
              "page-size": unref(pagination).pageSize,
              "current-page": unref(pagination).pageNo,
              layout: "total,slot, sizes, prev, pager, next, jumper",
              total: unref(pagination).pageTotal
            }, {
              default: withCtx(() => [
                createElementVNode("span", _hoisted_2, toDisplayString(unref(pagination).pageNo) + "/" + toDisplayString(Math.ceil(unref(pagination).pageTotal / unref(pagination).pageSize)) + "页", 1)
              ]),
              _: 1
            }, 8, ["hide-on-single-page", "page-size", "current-page", "total"])) : createCommentVNode("", !0)
          ]),
          _: 3
        }, 8, ["model", "rules"])) : createCommentVNode("", !0)
      ]);
    };
  }
};
export {
  _sfc_main as default
};
