import formUtil from "../../../utils/formUtil.js";
const imgIcon = {
  mounted(e, o, n, r) {
    const i = o.value.col, c = o.value.row;
    let a = e.parentNode.querySelector(".imgSpan");
    a && a.remove();
    let m = e.parentNode.querySelector(".imgIcon");
    if (m && m.remove(), i.showIconImg) {
      let t;
      if (i.showIconImg == "icon")
        t = document.createElement("span"), t.className = "imgIcon " + imgIcon.getIconImg(i, c);
      else if (i.showIconImg == "img") {
        t = document.createElement("span"), t.className = "imgSpan";
        let s = document.createElement("img");
        s.src = imgIcon.getIconImg(i, c), s.className = "imgIcon ", t.appendChild(s);
      }
      imgIcon.showIconExpr(i.showIconExpr, c) && (i.iconImgLocation == "before" ? e.parentNode.insertBefore(t, e) : i.iconImgLocation == "after" && e.parentNode.appendChild(t));
    }
  },
  /**
   * 根据表达式判断是否显示/隐藏图标
   */
  showIconExpr(condition, row) {
    if (!condition)
      return !0;
    let keys = formUtil.doExpression(condition);
    for (let e of keys.values()) {
      let o = row[e];
      !(o + "").startsWith("0") && !isNaN(o) || o === !0 || o === !1 || o === "true" || o === "false" ? condition = condition.replaceAll("${" + e + "}", o) : condition = condition.replaceAll("${" + e + "}", `'${o}'`);
    }
    try {
      return !!eval(condition);
    } catch (e) {
      return !0;
    }
  },
  /**
   * 根据条件判断要显示的图片/图标
   */
  getIconImg(e, o) {
    if (e.isIconSwitch) {
      for (let n of e.iconSwitchData)
        if (imgIcon.showIconExpr(n.expr, o)) {
          let r = n.value;
          return e.showIconImg == "img" ? (r.startsWith("/") && (r = r.substring(1)), window.productUrl + r) : r;
        }
    }
    if (e.showIconImg == "icon")
      return e.iconClass;
    {
      let n = e.imgPath;
      return n.startsWith("/") && (n = n.substring(1)), window.productUrl + n;
    }
  }
};
imgIcon.install = function(e) {
  e.directive("imgIcon", imgIcon);
};
export {
  imgIcon as default
};
