import S from "../../utils/getJsonAsyncUtil.js";
import { parseParamsFromRoute as b } from "../../utils/paramsUtil.js";
import d from "../../utils/formUtil.js";
import { post as h, sync as z } from "../../axios/index.js";
import p from "./queryModel/index.js";
import { initRule as C, initEvent as F } from "../forms/form/form.js";
import { getSuffix as T } from "../../utils/i18nUtil.js";
import K from "../../store/index.js";
import { nextTick as E, reactive as g } from "vue";
async function Q(e, t) {
  const r = e.tableId;
  let i = await S(r, "table", e.initOption);
  for (let l in i.columns)
    i.columns[l].prop && (i.columns[l].fieldName = i.columns[l].prop, delete i.columns[l].prop);
  t(i);
}
function $(e) {
  let t = {
    pageNo: 1,
    pageTotal: 0
  }, r = 10;
  return e.paginationPageSize ? r = e.paginationPageSize : e.pageInfoClass === "isLazy" && r.value < 20 && (r = 20), t.show = !1, e.pageInfoClass === "isPagination" || e.isPagination ? t.show = !0 : r = 0, t.pageSize = r, g(t);
}
function J(e) {
  let t = {
    show: e.isOptBtns,
    isAutoWidth: e.isBtnAutoWidth,
    data: e.optBtns
  };
  return t.isAutoWidth || (t.width = e.BtnWidth, t.minWidth = e.BtnMinWidth), t.moreBtnCut = 0, e.isMoreBtn && e.moreBtnCut > 0 && (t.moreBtnCut = e.moreBtnCut), g(t);
}
function v(e, t, r) {
  let i = e.url;
  i && (i = (e.appId || "") + i, h(i, t, e.isLoading).then((l) => {
    let f = l.records || l;
    f = w(f, e), r.value = {
      tableData: f,
      pageNo: l.current,
      // 当前页数
      pageSize: l.size,
      // 每页数量
      pageTotal: l.total
      // 页面总数
    };
  }));
}
function G(e, t, r) {
  let i = {};
  if (t.isAutoHeight) {
    let l = e.value.$el.parentNode.parentNode.parentNode.offsetHeight;
    i.height = null, i.maxHeight = l, r && (i.maxHeight -= 40);
  } else
    i.height = t.height, i.maxHeight = t.maxHeight;
  return g(i);
}
function U(e, t, r, i) {
  if (t) {
    if (r.isRadio) {
      for (let l in i.value)
        if (i.value[l][r.pkey || r.selectKey] == t) {
          e.value.setCurrentRow(i.value[l]);
          break;
        }
    } else
      for (let l in i.value)
        for (let f in t)
          if (i.value[l][r.pkey || r.selectKey] == t[f]) {
            e.value.toggleRowSelection(i.value[l], !0);
            break;
          }
  }
}
function V(e) {
  switch (e.modelType) {
    case "queryModel":
      return p.FixedQueryModel;
    case "dynamicModel":
      return p.DynamicQueryModel;
    case "expandModel":
      return p.CompostionQueryModel;
    case "nothingModel":
      return null;
  }
}
function _(e, t) {
  for (let r of e.value)
    k(r, t);
}
function k(e, t) {
  t.columns.forEach((r) => {
    if (r.fieldName) {
      if (r.fieldType == "multipleSelection") {
        let i = e[r.fieldName] || [];
        Array.isArray(i) ? e[r.fieldName] = i : e[r.fieldName] = i.split("|");
      }
      e.isRowEdit = !0;
    }
  });
}
function X(e, t, r) {
  e.editRowIndex = t, e.editFieldName = r;
}
function Y(e, t) {
  return (e.row.isRowEdit || e.row.editRowIndex == e.$index && e.row.editFieldName == t.fieldName) && !t.disableEdit;
}
function Z(e, t, r) {
  let i = {}, l = [], f = [];
  r.columns.forEach((o) => {
    o.fieldName && o.fieldType == "multipleSelection" && (i[o.fieldName] = !0);
  });
  for (let o in e.value) {
    let a = e.value[o];
    for (const n in i) {
      let s = a[n];
      Array.isArray(s) && (a[n] = s.join("|"));
    }
    a.isNewRow ? l.push(a) : d.isObjEqual(a, t[o]) || f.push(a);
  }
  return {
    newData: l,
    updateData: f
  };
}
function x(e, t, r) {
  t.value = C(e.columns, r, {});
}
function ee(e, t, r) {
  t.value = F(e.columns, r);
}
async function te(e, t) {
  let r = {}, i = e.columns, l = [];
  for (let o in i) {
    let a = i[o];
    if (a.fieldName != "") {
      if (a.optionType == "1")
        r[a.fieldName] = a.dicItem;
      else if (a.dicKey && a.optionType == "2") {
        let n = a.dicKey, s = a.fieldName;
        l.push({
          dicKey: n,
          fieldName: s
        });
      } else if (a.dataType === "library" && a.optionType == "3")
        try {
          let n = a.library.url, s = b(a.library.searchDataStr), u = await z.post(n, s, !1);
          if (!u.code || u.code === 0) {
            let y = [], m = [];
            u.list ? m = u.list.records || u.list : u.data ? m = u.data : m = u;
            let c = a.library.realField || "optCode", M = a.library.showField || "optName";
            for (let N in m) {
              let A = {
                optCode: m[N][c],
                optName: m[N][M]
              };
              y.push(A);
            }
            r[a.fieldName] = y;
          }
        } catch {
        }
    }
  }
  let f = [];
  for (let o in l)
    f.push(l[o].dicKey);
  try {
    const o = await d.getParmDicSync(f);
    for (let a in l)
      r[l[a].fieldName] = o[l[a].dicKey];
  } catch {
  }
  t.value = r;
}
function I(e, t, r, i) {
  const { columns: l, data: f } = t;
  if (i == "allSum" && f.length > 0) {
    let a = sessionStorage.getItem(r);
    return a = JSON.parse(a), a.pageNo = 1, a.pageSize = 0, h(
      e.url,
      a,
      (n) => {
        if (n.code == 0) {
          let s = n.list;
          t.data = s.records || s;
          let u = I(e, t, r, "currentSum"), y = document.querySelector(
            ".el-table__footer-wrapper>table"
          );
          for (let m = 0; m < u.length; m++)
            for (let c = 0; c < y.rows[0].children.length; c++)
              y.rows[0].children[m].innerHTML = '<div class="cell">' + u[m] + "</div>";
        }
      }
    ), [];
  }
  if (t.columns != null) {
    var o = [];
    return l.forEach((a, n) => {
      let s = null;
      if (e.columns.forEach((u, y) => {
        if (a.property == u.fieldName)
          return s = u, !1;
      }), e.summationAddr === void 0 && n === 0) {
        o[0] = e.summationName;
        return;
      }
      if (e.summationAddr === "front" && n === 0) {
        o[n] = e.summationName;
        return;
      }
      if (e.summationAddr === "after" && n === l.length - 1) {
        o[n] = e.summationName;
        return;
      }
      if (a.property && s && s.fieldType == "text" && s.dataType) {
        const u = f.map((y) => Number(y[a.property]));
        u.every((y) => isNaN(y)) ? o[n] = "" : (o[n] = u.reduce((y, m) => {
          const c = Number(m);
          return isNaN(c) ? y : y + m;
        }, 0), s.dataType == "money(yuan)" ? o[n] = d.formatMoney(o[n]) : s.dataType == "money(qian)" ? o[n] = d.formatMoney(Number(o[n]) / 1e3, 2) : s.dataType == "money(wan)" ? o[n] = d.formatMoney(Number(o[n]) / 1e4, 2) : s.dataType == "percentile" ? o[n] = d.numMulti(o[n], 100) : s.dataType == "thousand" ? o[n] = d.numMulti(o[n], 1e3) : s.dataType == "tenThousand" && (o[n] = d.numMulti(o[n], 1e4)), o[n] += T(s) || "");
      } else {
        o[n] = "";
        return;
      }
    }), o;
  }
}
function ie(e, t, r, i, l) {
  let f = {
    treeKeyValue: e[i.treeKey],
    pageNo: 1,
    pageSize: 0,
    tableId: l
  };
  h(
    i.url,
    f,
    (o) => {
      if (o.code == 0) {
        let a = o.list, n = a.records || a;
        n = w(n, i), r(n);
      }
    }
  );
}
function w(e, t) {
  if (t.isTree) {
    let r = [];
    for (let i of e) {
      let l = e.filter((f) => i[t.treeKey] == f[t.treeParentKey] ? (r.push(f[t.treeKey]), !0) : !1);
      l.length > 0 && (i.children = l), i.hasChildren = !0;
    }
    for (let i = e.length - 1; i >= 0; i--)
      r.indexOf(e[i][t.treeKey]) > -1 && e.splice(i, 1);
  }
  return e;
}
function B(e, t, r) {
  for (let i of t)
    i.children && i.children.length > 0 && (e.value.store.states.lazyTreeNodeMap.value[i[r.treeKey]] = i.children, E(() => {
      e.value.toggleRowExpansion(i, !0);
    }), B(e, i.children, r));
}
function re(e, t, r = {}) {
  if (typeof e > "u" || e == null)
    return e;
  if (t.isI18n)
    try {
      e = JSON.parse(e)[K.getters.i18n] || e;
    } catch {
    }
  if (t.fieldType === "checkbox" || t.fieldType === "multipleSelection") {
    let i;
    Array.isArray(e) ? i = e : i = e.split("|");
    let l = r, f = [];
    for (let o in i) {
      let a = i[o];
      for (let n in l)
        if (l[n].optCode == a) {
          t.optionType == "1", a = l[n].optName;
          break;
        }
      f.push(a);
    }
    e = f.join("丨");
  } else if (t.fieldType === "radio" || t.fieldType === "select") {
    let i = r;
    for (let l in i)
      if (i[l].optCode == e) {
        t.optionType == "1", e = i[l].optName;
        break;
      }
  } else if (t.fieldType === "text") {
    let i = !1;
    if (t.converData && t.converData.length > 0) {
      for (let l of t.converData)
        if (l.originalData == e) {
          e = l.newData, i = !0;
          break;
        }
    }
    i || (t.dataType === "money(yuan)" ? e = d.formatMoney(e) : t.dataType === "money(qian)" ? e = d.formatMoney(Number(e) / 1e3, 2) : t.dataType === "money(wan)" ? e = d.formatMoney(Number(e) / 1e4, 2) : t.dataType === "percentile" ? e = d.numMulti(e, 100) : t.dataType === "thousand" ? e = d.numMulti(e, 1e3) : t.dataType === "tenThousand" && (e = d.numMulti(e, 1e4)), e += T(t) || "");
  } else if (t.fieldType === "date" || t.fieldType === "time" || t.fieldType === "dateGroup" || t.fieldType === "datetime" || t.fieldType === "datetimeGroup")
    try {
      let i = t.dateFormat.format;
      if (!isNaN(e) && (e + "").length == 13) {
        let l = new Date(e);
        e = d.dateFormat(l, i);
      } else {
        let l = t.dateFormat.valueFormat;
        e = d.dateFormat(
          d.formatDate(e, l),
          i
        );
      }
    } catch {
      console.error(t.fieldName + "日期数据解析错误");
    }
  if (t.desensitization) {
    let i = {
      desensitization: t.desensitization,
      front: t.desensitizationFront,
      after: t.desensitizationAfter
    };
    e = d.desensitization(e, i);
  }
  return e;
}
export {
  X as editTableCell,
  k as editTableRow,
  Z as getEditTableData,
  w as getRootTreeData,
  I as getSummaries,
  _ as initEditTable,
  ee as initEvent,
  J as initOptBtnsCol,
  Q as initOption,
  $ as initPagination,
  te as initPramDicItem,
  x as initRule,
  U as initSelectionRows,
  v as initTableData,
  G as initTableHeight,
  V as initTableQueryModel,
  Y as isEditRowOrCell,
  B as setLazyTreeNodeMap,
  re as tableFormatter,
  ie as treeLoads
};
