import n from "vuex-persistedstate";
import { createStore as r } from "vuex";
const i = r({
  plugins: [
    n({
      key: "vuex",
      storage: window.sessionStorage
    })
  ],
  state: {
    buttonAuth: {},
    //用户信息
    refreshToken: "",
    token: "",
    buttonAuth: {},
    //列表按钮显隐权限所需
    buttons: [],
    //当前用户按钮权限
    productUrl: "/",
    devConfig: null,
    i18n: ""
  },
  getters: {
    buttonAuth: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).buttonAuth : e.buttonAuth;
    },
    refreshToken: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).refreshToken : e.refreshToken;
    },
    token: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).token : e.token;
    },
    buttons: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).buttons : e.buttons;
    },
    buttonAuth: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).buttonAuth : e.buttonAuth;
    },
    productUrl: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).productUrl || "/" : e.productUrl;
    },
    devConfig: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).devConfig : e.devConfig;
    },
    i18n: (e) => {
      const t = sessionStorage.getItem("vuex");
      return t ? JSON.parse(t).i18n : e.i18n;
    }
  },
  mutations: {
    set_token(e, t) {
      const s = sessionStorage.getItem("vuex");
      if (s) {
        const o = JSON.parse(s);
        o.token = t, sessionStorage.setItem("vuex", JSON.stringify(o)), e.token = t;
      }
    },
    set_refreshToken(e, t) {
      const s = sessionStorage.getItem("vuex");
      if (s) {
        const o = JSON.parse(s);
        o.refreshToken = t, sessionStorage.setItem("vuex", JSON.stringify(o)), e.refreshToken = t;
      }
    }
  },
  actions: {},
  modules: {}
});
export {
  i as default
};
