import i from "axios";
import r from "../store/index.js";
import d from "../router/index.js";
import c from "../utils/env.js";
import "../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../node_modules/element-plus/theme-chalk/el-message-box.css.js";
import "../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import "../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import "../../../node_modules/element-plus/theme-chalk/el-overlay.css.js";
import { ElMessageBox as k } from "../../../node_modules/element-plus/es/components/message-box/index.js";
const m = i.create({
  baseURL: c.api_base_url,
  timeout: c.api_timeout
}), s = /* @__PURE__ */ new Map();
m.interceptors.request.use(
  (e) => (o(e), p(e), e.url != "/login" && (e.headers.token = r.getters.token, e.headers.refreshToken = r.getters.refreshToken), e),
  (e) => {
    Promise.reject(e);
  }
);
m.interceptors.response.use(
  (e) => {
    o(e.config);
    const t = e.headers["refresh-token"], a = e.headers.token;
    return a && t && (r.commit("set_token", a), r.commit("set_refreshToken", t)), e.config.responseType == "blob" ? e : e.data && e.data.code == "500" ? (u(e.data.msg), Promise.reject(e.data)) : e.data.data;
  },
  async (e) => (e.config && o(e.config), i.isCancel(e) ? console.error("请求的重复请求：" + e.message) : (g(e), Promise.reject(e)))
);
function g(e) {
  let t = "", a = !1;
  if (e && e.response)
    switch (e.response.status) {
      case 302:
        t = "接口重定向了！";
        break;
      case 400:
        t = "参数不正确！";
        break;
      case 401:
        t = "您未登录，或者登录已经超时，请先登录！", a = !0;
        break;
      case 403:
        t = "您没有权限操作！";
        break;
      case 404:
        t = `请求地址未找到: ${e.response.config.url}`;
        break;
      case 408:
        t = "请求超时！";
        break;
      case 409:
        t = "系统已存在相同数据！";
        break;
      case 500:
        t = "服务器内部错误，请联系管理员！";
        break;
      case 501:
        t = "服务未实现！";
        break;
      case 502:
        t = "网关错误！";
        break;
      case 503:
        t = "服务暂时不可用！";
        break;
      case 504:
        t = "服务暂时无法访问，请稍后再试！", e.response.statusText.includes("Timeout") && (t = "网络请求超时！");
        break;
      case 505:
        t = "HTTP版本不受支持！";
        break;
      default:
        t = "异常问题，请联系管理员！";
        break;
    }
  e.message.includes("timeout") && (t = "网络请求超时！"), e.message.includes("Network") && (t = "服务端连接异常！"), u(t).then(() => {
    a && d.replace("/login");
  });
}
function u(e) {
  if (e && document.getElementsByClassName("axios-error-message-box").length === 0)
    return k.alert(e, "错误", {
      customClass: "axios-error-message-box",
      type: "error",
      draggable: !0
      // callback: (action) => {
      //   return new Promise((resolve) => {
      //     resolve();
      //   });
      // },
    });
}
function p(e) {
  const t = f(e);
  e.cancelToken = e.cancelToken || new i.CancelToken((a) => {
    s.has(t) || s.set(t, a);
  });
}
function o(e) {
  const t = f(e);
  s.has(t) && (s.get(t)(t), s.delete(t));
}
function f(e) {
  let { url: t, method: a, params: l, data: n } = e;
  return typeof n == "string" && (n = JSON.parse(n)), [t, a, JSON.stringify(l), JSON.stringify(n)].join("&");
}
export {
  m as default
};
