import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-date-picker.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-popper.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import { inject as u, computed as b, openBlock as T, createBlock as v, mergeProps as F, unref as n, isRef as h, toHandlers as V } from "vue";
import l from "../../../utils/formUtil.js";
import { getPlaceholder as O } from "../../../utils/i18nUtil.js";
import { ElDatePicker as S } from "../../../../../node_modules/element-plus/es/components/date-picker/index.js";
const C = {
  __name: "Date",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(d, { emit: f }) {
    u("formData");
    const p = u("changeFieldData"), a = d, y = f, m = b({
      get: () => {
        if (l.isTimestamp(a.modelValue)) {
          let e = s();
          return e = e.replace("YYYY", "yyyy"), e = e.replace("DD", "dd"), l.dateFormat(new Date(a.modelValue), e);
        } else
          return a.modelValue;
      },
      set: (e) => {
        y("update:modelValue", e);
      }
    });
    function c(e) {
      p && p(a.option.fieldName, e);
    }
    function s() {
      let e = "YYYY-MM-DD";
      return m.value == "99991231" && a.option.dateOption && a.option.dateOption.isLong === !0 ? e = "长期" : l.isEmpty(a.option.dateFormat.format) || (e = a.option.dateFormat.format.toUpperCase(), e = e.replace("HH:MM:SS", "HH:mm:ss")), e;
    }
    function D() {
      let e = null;
      return l.isEmpty(a.option.dateFormat.valueFormat) || (e = a.option.dateFormat.valueFormat.toUpperCase(), e = e.replace("HH:MM:SS", "HH:mm:ss")), e;
    }
    function g() {
      const e = a.option.dateOption;
      if (!e)
        return [];
      let t = [
        {
          text: "今天",
          value: /* @__PURE__ */ new Date()
        }
      ];
      return e.isLong === !0 && t.push({
        text: "长期",
        value: /* @__PURE__ */ new Date("9999/12/31")
      }), t;
    }
    function M(e) {
      const t = a.option.dateOption;
      let i = !0;
      if (!t)
        return i;
      if (t.bigDate || t.smallDate || t.defaultSmall || t.defaultBig) {
        let r = l.dateFormat(/* @__PURE__ */ new Date(), "yyyyMMdd");
        if (t.defaultSmall ? i = l.formatDate(r, "yyyyMMdd").getTime() > e.getTime() : t.smallDate && (i = l.formatDate(t.smallDate, "yyyyMMdd").getTime() > e.getTime()), t.defaultBig)
          if (t.smallDate || t.defaultSmall) {
            let o = l.formatDate(r, "yyyyMMdd");
            o && (i = i || e.getTime() > o.getTime());
          } else {
            let o = l.formatDate(r, "yyyyMMdd");
            o && (i = e.getTime() > o.getTime());
          }
        else if (t.bigDate && t.smallDate || t.defaultSmall) {
          let o = l.formatDate(t.bigDate, "yyyyMMdd");
          o && (i = i || e.getTime() > o.getTime());
        } else {
          let o = l.formatDate(t.bigDate, "yyyyMMdd");
          o && (i = e.getTime() > o.getTime());
        }
        return i;
      }
    }
    return (e, t) => {
      const i = S;
      return T(), v(i, F({
        ref: "dateRef",
        modelValue: n(m),
        "onUpdate:modelValue": t[0] || (t[0] = (r) => h(m) ? m.value = r : null),
        format: s(),
        "value-format": D(),
        type: a.option.dateType,
        placeholder: n(O)(a.option),
        disabled: n(l).isEmpty(a.option.disabled) ? !1 : a.option.disabled,
        readonly: n(l).isEmpty(a.option.readOnly) ? !1 : a.option.readOnly,
        shortcuts: g(),
        "disabled-date": M
      }, V(d.event), { onChange: c }), null, 16, ["modelValue", "format", "value-format", "type", "placeholder", "disabled", "readonly", "shortcuts"]);
    };
  }
};
export {
  C as default
};
