import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-date-picker.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-scrollbar.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-popper.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import { inject as m, ref as g, computed as F, openBlock as b, createBlock as v, mergeProps as V, unref as o, isRef as E, toHandlers as S } from "vue";
import a from "../../../utils/formUtil.js";
import { getPlaceholder as D, getEndPlaceholder as T } from "../../../utils/i18nUtil.js";
import { ElDatePicker as M } from "../../../../../node_modules/element-plus/es/components/date-picker/index.js";
const G = {
  __name: "DateGroup",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String,
    isEdit: {
      type: Boolean,
      default: !1
    },
    isTableSearch: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue"],
  setup(l, { emit: d }) {
    m("formData");
    const p = m("changeFieldData"), e = l, n = g(e.option.dateType);
    e.isEdit && (e.option.fieldType == "dateGroup" || e.option.fieldType == "datetimeGroup") && (n.value = "date");
    const s = d, r = F({
      get: () => e.modelValue,
      set: (t) => {
        s("update:modelValue", t);
      }
    });
    function u(t) {
      p && p(e.option.fieldName, t);
    }
    function f() {
      let t = "YYYY-MM-DD";
      return a.isEmpty(e.option.dateFormat.format) || (t = e.option.dateFormat.format.toUpperCase(), t = t.replace("HH:MM:SS", "hh:mm:ss")), e.isTableSearch && (t = t.replace("hh:mm:ss", "")), t;
    }
    function c() {
      let t = null;
      return a.isEmpty(e.option.dateFormat.valueFormat) || (t = e.option.dateFormat.valueFormat.toUpperCase(), t = t.replace("HH:MM:SS", "hh:mm:ss")), e.isTableSearch && (t = t.replace("hh:mm:ss", "")), t;
    }
    return (t, i) => {
      const h = M;
      return b(), v(h, V({
        ref: "dateRef",
        modelValue: o(r),
        "onUpdate:modelValue": i[0] || (i[0] = (y) => E(r) ? r.value = y : null),
        format: f(),
        "value-format": c(),
        type: o(n),
        "unlink-panels": "",
        "range-separator": e.option.separator,
        "start-placeholder": o(D)(e.option),
        "end-placeholder": o(T)(e.option),
        disabled: o(a).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
        readonly: o(a).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly
      }, S(l.event), { onChange: u }), null, 16, ["modelValue", "format", "value-format", "type", "range-separator", "start-placeholder", "end-placeholder", "disabled", "readonly"]);
    };
  }
};
export {
  G as default
};
