import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-input.css.js";
import { inject as p, ref as d, computed as f, openBlock as I, createElementBlock as N, Fragment as O, createVNode as c, mergeProps as R, unref as a, isRef as g, toHandlers as D, withCtx as S, createTextVNode as E, toDisplayString as z } from "vue";
import v from "../../../utils/formUtil.js";
import j from "../../i18n/I18nDialog.vue.js";
import k from "../../../store/index.js";
import { getPlaceholder as F, getSuffix as U } from "../../../utils/i18nUtil.js";
import { ElInput as B } from "../../../../../node_modules/element-plus/es/components/input/index.js";
const G = {
  __name: "Textarea",
  props: {
    option: {
      type: Object,
      default() {
        return {};
      }
    },
    event: Object,
    modelValue: String
  },
  emits: ["update:modelValue"],
  setup(V, { emit: x }) {
    const s = p("formData"), m = p("changeFieldData"), e = V, h = x, u = d(""), n = f({
      get: () => {
        let t = e.modelValue;
        if (e.option.isI18n)
          try {
            u.value = JSON.parse(
              s.value[e.option.fieldName + "_I18n"]
            );
          } catch {
            u.value = "", n.value = t;
          }
        else
          n.value = t;
        return t;
      },
      set: (t) => {
        h("update:modelValue", t);
      }
    });
    function w(t) {
      m && m(e.option.fieldName, t);
    }
    const y = f(() => {
      let t = {};
      return e.option.isAutoRows ? t.minRows = 3 : (t.minRows = e.option.minRows || 3, t.maxRows = e.option.maxRows || 6), t;
    }), i = d(!1);
    function b() {
      e.option.isI18n && (i.value = !0, readOnly.value = !0);
    }
    function _(t) {
      let o = {}, r = "";
      t.forEach((l) => {
        o[l.lang] = l.content, l.lang == k.getters.i18n && (r = l.content);
      }), n.value = r, s.value[e.option.fieldName + "_I18n"] = JSON.stringify(o), i.value = !1;
    }
    return (t, o) => {
      const r = B;
      return I(), N(O, null, [
        c(r, R({
          ref: "input",
          type: "textarea",
          modelValue: a(n),
          "onUpdate:modelValue": o[0] || (o[0] = (l) => g(n) ? n.value = l : null),
          placeholder: a(F)(e.option)
        }, D(e.event), {
          onClick: b,
          maxlength: e.option.maxlength,
          "show-word-limit": !!e.option.maxlength,
          disabled: a(v).isEmpty(e.option.disabled) ? !1 : e.option.disabled,
          readonly: a(v).isEmpty(e.option.readOnly) ? !1 : e.option.readOnly,
          clearable: !0,
          autocomplete: "off",
          autosize: a(y),
          resize: "none",
          onInput: w
        }), {
          suffix: S(() => [
            E(z(a(U)(e.option)), 1)
          ]),
          _: 1
        }, 16, ["modelValue", "placeholder", "maxlength", "show-word-limit", "disabled", "readonly", "autosize"]),
        c(j, {
          modelValue: a(i),
          "onUpdate:modelValue": o[1] || (o[1] = (l) => g(i) ? i.value = l : null),
          title: e.option.label,
          data: a(u),
          onSubmit: _
        }, null, 8, ["modelValue", "title", "data"])
      ], 64);
    };
  }
};
export {
  G as default
};
