import { ref as i, computed as v, resolveComponent as d, openBlock as h, createBlock as y, unref as s, isRef as R, withCtx as k, createVNode as D } from "vue";
import I from "../../store/index.js";
const B = {
  __name: "I18nDialog",
  props: {
    title: {
      type: String,
      default: ""
    },
    entitle: {
      type: String,
      default: ""
    },
    data: {
      type: Object,
      default: ""
    },
    modelValue: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "submit"],
  setup(r, { expose: m, emit: f }) {
    const t = r;
    function c() {
      let e = "";
      switch (I.getters.i18n) {
        case "en_US":
          e = t.entitle;
          break;
        default:
          e = t.title || "标题";
          break;
      }
      return e || (e = t.title), e;
    }
    const l = i([]), u = f, o = v({
      get: () => {
        if (t.modelValue && (l.value = [], t.data))
          for (let e in t.data)
            l.value.push({
              lang: e,
              content: t.data[e],
              isNewRow: !0,
              isRowEdit: !0
            });
        return t.modelValue;
      },
      set: (e) => {
        u("update:modelValue", e);
      }
    });
    function p() {
      u("submit", l.value);
    }
    const n = i();
    function b() {
      n.value.addRow();
    }
    function _(e, a) {
      n.value.delRow(a);
    }
    return m({
      addi18nItem: b,
      delI18nItem: _
    }), (e, a) => {
      const g = d("h-table"), w = d("h-custom-dialog");
      return h(), y(w, {
        modelValue: s(o),
        "onUpdate:modelValue": a[0] || (a[0] = (V) => R(o) ? o.value = V : null),
        title: c(),
        onSubmit: p
      }, {
        default: k(() => [
          D(g, {
            tableId: "sys/i18n/i18nDialogTable",
            ref_key: "tableRef",
            ref: n,
            tableData: s(l)
          }, null, 8, ["tableData"])
        ]),
        _: 1
      }, 8, ["modelValue", "title"]);
    };
  }
};
export {
  B as default
};
