import "../../../../../node_modules/element-plus/theme-chalk/base.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-collapse-transition.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-button.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-form.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-form-item.css.js";
import "../../../../../node_modules/element-plus/theme-chalk/el-icon.css.js";
import { ref as _, inject as F, resolveComponent as b, openBlock as o, createElementBlock as u, createElementVNode as m, createBlock as y, withCtx as p, createVNode as n, createCommentVNode as c, toDisplayString as P, unref as r, isRef as k, withDirectives as U, Fragment as d, renderList as x, createTextVNode as V, vShow as G } from "vue";
import "../../../store/index.js";
import { formItem as T } from "../../forms/formItem/index.js";
import L from "../components/QueryModelCustomBtns.vue.js";
import W from "../components/QueryModelBtns.vue.js";
import z from "../components/QueryModelTabs.vue.js";
import A from "../components/QueryModelInput.vue.js";
import { getFormValue as H } from "../../forms/form/interface/getFormValue.js";
import "./CompostionQueryModel.vue2.js";
import { ElIcon as J } from "../../../../../node_modules/element-plus/es/components/icon/index.js";
import { ElFormItem as K, ElForm as X } from "../../../../../node_modules/element-plus/es/components/form/index.js";
import { ElButton as Y } from "../../../../../node_modules/element-plus/es/components/button/index.js";
import { ElCollapseTransition as Z } from "../../../../../node_modules/element-plus/es/components/collapse-transition/index.js";
const ee = { class: "query-model-tools-div compostionQueryModel" }, te = { class: "compostionQueryModelContext" }, oe = { class: "compostionQueryModelDiv" }, ne = {
  key: 1,
  class: "title"
}, re = { class: "query-model-btn-div" }, le = { class: "expandSreachBtns" }, ae = /* @__PURE__ */ m("span", null, "收起", -1), ie = /* @__PURE__ */ m("span", null, "展开", -1), Te = {
  __name: "CompostionQueryModel",
  props: {
    option: {
      type: Object,
      required: !0
    },
    pramDicItem: {
      type: Object,
      default() {
        return [];
      }
    },
    sessionPageData: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(v, { expose: S }) {
    const e = v, C = _(), Q = _();
    let l = _(!1);
    function E() {
      l.value ? l.value = !1 : l.value = !0;
    }
    const a = _({});
    g("init");
    function g(i) {
      a.value = {};
      for (let t of e.option.columns)
        if (t.isQuery || t.isOtherQuery) {
          let f = null;
          i == "init" && (f = e.sessionPageData[t.fieldName], f && (l.value = !0)), a.value[t.fieldName] = f || t.value;
        }
    }
    const N = F("searchTable");
    function w() {
      const i = H(e.option.columns, a.value);
      N(i);
    }
    function B() {
      g(), w();
    }
    function M() {
      if (e.option.hasOther)
        return !0;
      for (let i of e.option.columns)
        if (i.isQuery)
          return !0;
      return !1;
    }
    return S({
      getCurrTabQuery: () => {
        try {
          return C.value.getCurrTabQuery();
        } catch {
          return null;
        }
      },
      getDynamicQuery: () => {
        try {
          return Q.value.getDynamicQuery();
        } catch {
          return null;
        }
      }
    }), (i, t) => {
      const f = b("arrow-left-bold"), h = J, q = K, O = X, I = Y, $ = Z, R = b("arrow-up"), j = b("arrow-down");
      return o(), u("div", ee, [
        m("div", te, [
          m("div", oe, [
            m("div", null, [
              v.option.isShowGoBack !== !1 ? (o(), y(h, {
                key: 0,
                class: "goBack",
                onClick: t[0] || (t[0] = (s) => i.$router.back(-1))
              }, {
                default: p(() => [
                  n(f)
                ]),
                _: 1
              })) : c("", !0),
              e.option.isShowTitle !== !1 ? (o(), u("span", ne, P(e.option.tableName), 1)) : c("", !0),
              n(r(z), {
                option: e.option,
                ref_key: "queryModelTabsRef",
                ref: C
              }, null, 8, ["option"])
            ]),
            m("div", null, [
              n(r(A), {
                option: e.option,
                searchData: e.sessionPageData.dynamicQuery,
                onCloseCollapse: t[1] || (t[1] = (s) => k(l) ? l.value = !1 : l = !1),
                ref_key: "queryModelInputRef",
                ref: Q
              }, null, 8, ["option", "searchData"]),
              m("div", re, [
                n(r(L), {
                  option: e.option
                }, null, 8, ["option"]),
                n(r(W), {
                  option: e.option,
                  pramDicItem: v.pramDicItem
                }, null, 8, ["option", "pramDicItem"])
              ])
            ])
          ]),
          n($, { class: "expandSearchCollapse" }, {
            default: p(() => [
              U(m("div", null, [
                n(O, {
                  "label-position": "right",
                  "label-width": "100px"
                }, {
                  default: p(() => [
                    (o(!0), u(d, null, x(e.option.columns, (s) => (o(), u(d, null, [
                      s.isQuery ? (o(), y(r(T), {
                        key: 0,
                        option: s,
                        modelValue: r(a),
                        "onUpdate:modelValue": t[2] || (t[2] = (D) => k(a) ? a.value = D : null),
                        pramDicItem: e.pramDicItem[s.fieldName],
                        event: []
                      }, null, 8, ["option", "modelValue", "pramDicItem"])) : c("", !0)
                    ], 64))), 256)),
                    e.option.hasOther ? (o(), y(q, {
                      key: 0,
                      class: "otherWidgets",
                      label: "其他"
                    }, {
                      default: p(() => [
                        (o(!0), u(d, null, x(e.option.columns, (s) => (o(), u(d, null, [
                          s.isOtherQuery ? (o(), y(r(T), {
                            key: 0,
                            option: s,
                            modelValue: r(a),
                            "onUpdate:modelValue": t[3] || (t[3] = (D) => k(a) ? a.value = D : null),
                            pramDicItem: e.pramDicItem[s.fieldName],
                            event: []
                          }, null, 8, ["option", "modelValue", "pramDicItem"])) : c("", !0)
                        ], 64))), 256))
                      ]),
                      _: 1
                    })) : c("", !0)
                  ]),
                  _: 1
                }),
                m("div", le, [
                  n(I, {
                    type: "primary",
                    "native-type": "submit",
                    onClick: w
                  }, {
                    default: p(() => [
                      V("查询")
                    ]),
                    _: 1
                  }),
                  n(I, { onClick: B }, {
                    default: p(() => [
                      V("重置")
                    ]),
                    _: 1
                  })
                ])
              ], 512), [
                [G, r(l)]
              ])
            ]),
            _: 1
          })
        ]),
        M() ? (o(), u("div", {
          key: 0,
          class: "expandBtn",
          onClick: E
        }, [
          r(l) ? (o(), u(d, { key: 0 }, [
            ae,
            n(h, null, {
              default: p(() => [
                n(R)
              ]),
              _: 1
            })
          ], 64)) : (o(), u(d, { key: 1 }, [
            ie,
            n(h, null, {
              default: p(() => [
                n(j)
              ]),
              _: 1
            })
          ], 64))
        ])) : c("", !0)
      ]);
    };
  }
};
export {
  Te as default
};
