import { get, sync } from "../axios/index.js";
import { Decimal } from "../../../node_modules/decimal.js/decimal.js";
import store from "../store/index.js";
const getParmDic = function(e, t) {
  const r = e.join(",");
  if (!r)
    return {};
  let i = "/parm/sysParmDic/getDicListByKey/" + r;
  get(i, !1).then((n) => {
    isFunction(t) && t(n);
  }).error((n) => {
    console.error(n), isFunction(t) && t({});
  });
}, getParmDicSync = async function(e) {
  const t = e.join(",");
  if (!t)
    return {};
  let r = $servers.sys + "/parm/sysParmDic/getDicListByKey/" + t;
  return await sync.get(r, !1);
}, parsFieldName = function(e, t, r) {
  var i = /^\${.*}$/;
  if (i.test(e) == !0) {
    let n = e.replace(/^(\s|\${)+|(\s|})+$/g, ""), s = store.getters.buttonAuth || {};
    s[n] ? e = s[n] : e = t[n], r && ((e === void 0 || e === "") && (e = r.query[n]), (e === void 0 || e === "") && (e = r.params[n]));
  }
  return e;
}, isEmpty = function(e) {
  return e == null || e === "" || e === !1;
}, isNumber = function(e) {
  var t = /^[0-9]+.?[0-9]*/;
  return !!(t.test(e) && Number(e) > 0 && !(e + "").startsWith("0"));
}, parentVmExist = function(e, t) {
  if (!t)
    return null;
  const r = getParentVm(e, t);
  return r || console.error(t + "函数不存在"), r;
};
function getParentVm(e, t) {
  return e ? isFunction(e[t]) ? e : getParentVm(e.$parent, t) : null;
}
const isFunction = function(e) {
  return typeof e == "function";
}, setgetCursorPsn = function(e, t) {
  if (e.setSelectionRange)
    e.focus(), e.setSelectionRange(t, t);
  else if (e.createTextRange) {
    var r = e.createTextRange();
    r.collapse(!0), r.moveEnd("character", t), r.moveStart("character", t), r.select();
  }
}, getOstr = function(e, t) {
  var r = 0, i = e.value;
  if (i.length > 0)
    for (var n = i.substring(0, t), s = 0; s < n.length; s++) {
      var f = n.charAt(s);
      isNaN(f) && r++;
    }
  return r;
}, getCursorPsn = function(e) {
  var t = 0, r = e;
  if (document.selection) {
    r.focus();
    var i = document.selection.createRange();
    i.moveStart("character", -r.value.length), t = i.text.length;
  } else
    (r.selectionStart || r.selectionStart == "0") && (t = r.selectionStart);
  return t;
}, toMoney = function(e) {
  if (e) {
    let c = e.target;
    var t = c.value;
    c.value = ToCDB(t);
    var r = getCursorPsn(c), i = getOstr(c, r);
    t = c.value, t = delcommafy(t), t = moneyCheck(t);
    var n, s, f, a = 0, o = 0;
    for (n = 0; n < t.length; n++) {
      if (s = t.charAt(n), isNaN(parseInt(s, 10)) && s != "." && s != "," && s != "-") {
        o == 1 ? c.value = "-" + t.substring(0, n) + t.substring(n + 1, t.length) : c.value = t.substring(0, n) + t.substring(n + 1, t.length);
        return;
      }
      if (n > 0 && s == "-") {
        o == 1 ? c.value = "-" + t.substring(0, n) + t.substring(n + 1, t.length) : c.value = t.substring(0, n) + t.substring(n + 1, t.length);
        return;
      }
      n == 0 && s == "-" && (o = 1, t = t.substr(1, t.length), n = -1), s != "0" && (a = 1), a == 0 && n == 1 && s == "0" && (t = t.substr(1, t.length - 1), n = 0);
    }
    var u;
    if (u = t.split("."), u.length > 2) {
      c.focus(), c.select();
      return;
    }
    var g, d;
    u.length == 2 && (d = u[1], d.length == 0 ? g = "" : d.length == 1 ? g = d + "" : g = d.substring(0, d.length));
    var m;
    m = u[0].split(",");
    var l = "";
    for (n = 0; n < m.length; n++)
      l += m[n];
    var h = "";
    for (l.length > 1 && l.charAt(0) == "0" && l.charAt(1) != "." && (l = l.substr(1, l.length - 1)); l.length > 3; )
      h = "," + l.substring(l.length - 3, l.length) + h, l = l.substring(0, l.length - 3);
    h = l + h, g == null ? f = h : f = h + "." + g, o == 1 && (f = "-" + f), c.value = f;
    var y = getOstr(c, r);
    return r = r + (y - i), setgetCursorPsn(c, r), c.value;
  }
}, ToCDB = function(e) {
  for (var t = "", r = 0; r < e.length; r++)
    e.charCodeAt(r) > 65248 && e.charCodeAt(r) < 65375 ? t += String.fromCharCode(e.charCodeAt(r) - 65248) : t += String.fromCharCode(e.charCodeAt(r));
  return t;
}, moneyCheck = function(e) {
  var t = e, r = t.substr(0, 1), i = t.substr(1, 1);
  if (t.length > 1 && r == 0 && i != "." && (t = t.substr(1, 1)), r == "." && (t = ""), t.indexOf(".") != -1) {
    var n = t.substr(t.indexOf(".") + 1);
    n.indexOf(".") != -1 && (t = t.substr(0, t.indexOf(".") + n.indexOf(".") + 1));
  }
  return t = t.replace(/[^\d^\.]+/g, ""), t;
}, delcommafy = function(e) {
  return e && (e = e.toString(), e = e.replace(/,/gi, ""), e);
}, formatMoney = (e, t = 2, r = ".", i = ",") => {
  if (Number(e) < 0.01 && Number(e) > 0)
    return e;
  e = delcommafy(e), e = (e + "").replace(/[^0-9+-Ee.]/g, "");
  let n = isFinite(+e) ? +e : 0, s = isFinite(+t) ? Math.abs(t) : 0, f = typeof i > "u" ? "," : i, a = typeof r > "u" ? "." : r, o = "";
  o = (s ? function(d, m) {
    let l = Math.pow(10, m);
    return "" + Math.round(numMulti(d, l)) / l;
  }(n, s) : "" + Math.round(n)).split(".");
  let g = /(-?\d+)(\d{3})/;
  for (; g.test(o[0]); )
    o[0] = o[0].replace(g, "$1" + f + "$2");
  return (o[1] || "").length < s && (o[1] = o[1] || "", o[1] += new Array(s - o[1].length + 1).join("0")), o.join(a);
}, func_uior_trim = function(e) {
  var t = "";
  return e != null && (t = e.replace(/^\s|\s$/g, "")), t;
}, validateInt = function(e, t, r) {
  if (t) {
    var i = /^-?[0-9]*$/;
    i.test(t) ? r() : r(new Error("内容不是整数!"));
  } else
    r();
}, GetIdVerifyBit = function(id) {
  var result, nNum = eval(
    id.charAt(0) * 7 + id.charAt(1) * 9 + id.charAt(2) * 10 + id.charAt(3) * 5 + id.charAt(4) * 8 + id.charAt(5) * 4 + id.charAt(6) * 2 + id.charAt(7) * 1 + id.charAt(8) * 6 + id.charAt(9) * 3 + id.charAt(10) * 7 + id.charAt(11) * 9 + id.charAt(12) * 10 + id.charAt(13) * 5 + id.charAt(14) * 8 + id.charAt(15) * 4 + id.charAt(16) * 2
  );
  switch (nNum = nNum % 11, nNum) {
    case 0:
      result = "1";
      break;
    case 1:
      result = "0";
      break;
    case 2:
      result = "X";
      break;
    case 3:
      result = "9";
      break;
    case 4:
      result = "8";
      break;
    case 5:
      result = "7";
      break;
    case 6:
      result = "6";
      break;
    case 7:
      result = "5";
      break;
    case 8:
      result = "4";
      break;
    case 9:
      result = "3";
      break;
    case 10:
      result = "2";
      break;
  }
  return result;
}, validateIdNo = function(e, t, r) {
  t || r();
  var i = t, n = i.length;
  if (n != 15 && n != 18 && r(new Error("身份证号长度应为15位或18位！")), n == 15) {
    var s = /^\d{15}$/;
    s.test(i) || r(new Error("15位身份证号必须为数字")), "" + i.substring(6, 8);
    let f = i.substring(8, 10), a = i.substring(10, 12);
    (f > 12 || f <= 0) && r(new Error("输入身份证号,月份非法！")), (a > 31 || a <= 0) && r(new Error("输入身份证号,日期非法！"));
  } else if (n == 18) {
    var s = /^\d{17}[\dXx]$/;
    s.test(i) || r(new Error("身份证前17位必须为数字,第18位为数字或X"));
    let a = i.substring(6, 10);
    (a > (/* @__PURE__ */ new Date()).getFullYear() || a < 1800) && r(new Error("输入身份证号,年度非法！"));
    let o = i.substring(10, 12);
    (o > 12 || o <= 0) && r(new Error("输入身份证号,月份非法！"));
    let u = i.substring(12, 14);
    (u > 31 || u <= 0) && r(new Error("输入身份证号,日期非法！")), i.charAt(17) == "x" || i.charAt(17) == "X" ? GetIdVerifyBit(i) != "x" && GetIdVerifyBit(i) != "X" && r(new Error("身份证校验错误，请检查最后一位！")) : i.charAt(17) != GetIdVerifyBit(i) && r(new Error("身份证校验错误，请检查最后一位！"));
  }
  r();
}, validateLong = function(e, t, r) {
  if (t) {
    var i = /^-?[1-9]\d*|0$/;
    i.test(t) ? r() : r(new Error("内容不是长整数!"));
  } else
    r();
}, validateNumber = function(e, t, r) {
  if (t) {
    var i = /^-?([1-9]\d*|[1-9]\d*\.\d*|0\.\d*[1-9]\d*|0?\.0+|0)$/;
    i.test(t) ? r() : r(new Error("内容不是数字!"));
  } else
    r();
}, validateDate = function(e, t, r) {
}, validateFloat = function(e, t, r) {
  if (t) {
    var i = /^[1-9]\d*|[1-9]\d*\.\d*|0\.\d*[1-9]\d*|0?\.0+|0$/;
    i.test(t) ? r() : r(new Error("内容不是数字(正数)!"));
  } else
    r();
}, validateBoolean = function(e, t, r) {
  t && t != "true" && t != "false" ? r(new Error("内容不是布尔值!")) : r();
}, validateMoney = function(e, t, r) {
  t || r(), t = delcommafy(t);
  var i = /^-?([1-9]\d*|[1-9]\d*\.\d*|0\.\d*[1-9]\d*|0?\.0+|0)$/;
  if (!i.test(t))
    t ? r(new Error("内容不是金额类型!")) : r();
  else {
    var n = (t + "").split(".");
    n.length == 2 ? n[1].length > 2 ? r(new Error("金额类型只保留2位小数点!")) : r() : n.length == 1 ? r() : r(new Error("内容不是金额类型!"));
  }
}, func_uior_valTypeImm = function(e, t) {
  let r = e.target.value || "";
  if (r != null && t != "undefined" && func_uior_trim(t) != "") {
    if (t == "int") {
      if (r != "") {
        var i = /^-?[0-9]*$/;
        i.test(r) || (e.currentTarget.focus(), e.currentTarget.select());
      }
    } else if (t == "long") {
      if (r != "") {
        var i = /^-?[1-9]\d*|0$/;
        i.test(r) || (e.currentTarget.focus(), e.currentTarget.select());
      }
    } else if (t == "double(2)" || t == "double(4)" || t == "double(6)" || t == "money(fen)" || t == "money(jiao)" || // type == "money(wan)" ||
    // type == "money(yi)" ||
    t == "percentile" || t === "thousand" || t == "tenThousand") {
      if (r != "") {
        var i = /^-?([1-9]\d*|[1-9]\d*\.\d*|0\.\d*[1-9]\d*|0?\.0+|0)$/;
        i.test(r) || (e.currentTarget.focus(), e.currentTarget.select());
      }
    } else if (t == "float") {
      if (r != "") {
        var i = /^[1-9]\d*|[1-9]\d*\.\d*|0\.\d*[1-9]\d*|0?\.0+|0$/;
        i.test(r) || (e.currentTarget.focus(), e.currentTarget.select());
      }
    } else if (t == "boolean")
      r != "" && r != "true" && r != "false" && (e.currentTarget.focus(), e.currentTarget.select());
    else if (t === "money(yuan)") {
      var i = /^([+-]?)((\d{1,3}(,\d{3})*)|(\d+))(\.\d*)?$/;
      if (!i.test(r))
        r == "" || (e.currentTarget.focus(), e.currentTarget.select());
      else {
        var n = r.split(".");
        n.length == 2 ? n[1].length == 0 ? e.target.value = n[0] + ".00" : n[1].length == 1 ? e.target.value = r + "0" : n[1].length > 2 && (e.currentTarget.focus(), e.currentTarget.select()) : n.length == 1 ? e.target.value = r + ".00" : (e.currentTarget.focus(), e.currentTarget.select());
      }
    }
  }
}, bigAmt = function(e = 0) {
  e = (e + "").replace(/,/g, "");
  try {
    if (e = Number(e), e == 0)
      return "";
  } catch {
    return "";
  }
  var t = ["角", "分"], r = ["零", "壹", "贰", "叁", "肆", "伍", "陆", "柒", "捌", "玖"], i = [
    ["元", "万", "亿"],
    ["", "拾", "佰", "仟"]
  ], n = e < 0 ? "欠" : "";
  e = Math.abs(e);
  for (var s = "", f = 0; f < t.length; f++)
    s += (r[Math.floor(e * 10 * Math.pow(10, f)) % 10] + t[f]).replace(/零./, "");
  s = s || "整", e = Math.floor(e);
  for (var f = 0; f < i[0].length && e > 0; f++) {
    for (var a = "", o = 0; o < i[1].length && e > 0; o++)
      a = r[e % 10] + i[1][o] + a, e = Math.floor(e / 10);
    s = a.replace(/(零.)*零$/, "").replace(/^$/, "零") + i[0][f] + s;
  }
  return n + s.replace(/(零.)*零元/, "元").replace(/(零.)+/g, "零").replace(/^整$/, "零元整");
}, evalFunc = function() {
  try {
    var func = "arguments[0](";
    for (let e = 1; e < arguments.length; e++)
      e !== arguments.length - 1 ? func += "arguments[" + e + "]," : func += "arguments[" + e + "]";
    return func += ")", eval(func);
  } catch (e) {
    throw new Error("执行失败:" + e);
  }
}, desensitization = function(e, t) {
  let r = t.desensitization;
  if (r === "idNo")
    e = e.replace(/^(.{4})(?:\d+)(.{3})$/, "$1***********$2");
  else if (r === "mobile")
    e = e.replace(/^(.{3})(?:\d+)(.{4})$/, "$1****$2");
  else if (r === "bankNo") {
    let n = e.length, s = "$1";
    for (let f = 0; f < n - 8; f++)
      s += "*";
    s += "$2", e = e.replace(/^(.{4})(?:\d+)(.{4})$/, s);
  } else if (r === "normal") {
    let n = e.length, s = "$1";
    for (let f = 0; f < n - 6; f++)
      s += "*";
    s += "$2", e = e.replace(/^(.{3})(?:\w+)(.{3})$/, s);
  } else if (r === "custom") {
    let n = t.front || 0, s = t.after || 0, f = e.length, a = Number(n) + Number(s);
    if (a < f) {
      let o = "$1";
      for (let u = 0; u < f - a; u++)
        o += "*";
      o += "$2";
      var i = new RegExp("^(.{" + n + "})(?:\\w+)(.{" + s + "})$");
      e = e.replace(i, o);
    }
  }
  return e;
};
function numAdd(e, t) {
  return isEmpty(e) && (e = 0), isEmpty(t) && (t = 0), new Decimal(e).add(new Decimal(t)).toNumber();
}
function numSub(e, t) {
  return isEmpty(e) && (e = 0), isEmpty(t) && (t = 0), new Decimal(e).sub(new Decimal(t)).toNumber();
}
function numMulti(e, t) {
  return isEmpty(e) && (e = 0), isEmpty(t) && (t = 0), new Decimal(e).mul(new Decimal(t)).toNumber();
}
function numDiv(e, t) {
  return isEmpty(e) && (e = 0), isEmpty(t) && (t = 0), new Decimal(e).div(new Decimal(t)).toNumber();
}
const formatDate = function(e, t) {
  if (!e)
    return e;
  var r;
  return t == "yyyyMMdd" ? r = /* @__PURE__ */ new Date(
    e.substring(0, 4) + "/" + e.substring(4, 6) + "/" + e.substring(6, 8)
  ) : t == "yyyyMM" ? r = /* @__PURE__ */ new Date(e.substring(0, 4) + "/" + e.substring(4, 6)) : t == "yyyy-MM-dd" ? r = new Date(e.replace(/-/g, "/")) : t == "yyyy/MM/dd" ? r = new Date(e) : t == "yyyy年MM月dd日" ? r = new Date(
    e.replace(/年/g, "/").replace(/月/g, "/").replace(/日/g, "")
  ) : t == "yyyyMMdd HH:mm:ss" ? r = /* @__PURE__ */ new Date(
    e.substring(0, 4) + "/" + e.substring(4, 6) + "/" + e.substring(6, 17)
  ) : t == "yyyy-MM-dd HH:mm:ss" ? r = new Date(e.replace(/-/g, "/")) : t == "yyyy/MM/dd HH:mm:ss" ? r = new Date(e) : t == "yyyy年MM月dd日 HH:mm:ss" ? r = new Date(
    e.replace(/年/g, "/").replace(/月/g, "/").replace(/日/g, "")
  ) : r = new Date(e.replace(/-/g, "/")), r instanceof Date && !isNaN(r.getTime()) ? r : (r = new Date(e), isNaN(r) ? e : r);
};
function dateFormat(e, t) {
  if (e instanceof Date && !isNaN(e.getTime())) {
    let r;
    const i = {
      "y+": e.getFullYear().toString(),
      // 年
      "M+": (e.getMonth() + 1).toString(),
      // 月
      "d+": e.getDate().toString(),
      // 日
      "H+": e.getHours().toString(),
      // 时
      "m+": e.getMinutes().toString(),
      // 分
      "s+": e.getSeconds().toString()
      // 秒
      // 有其他格式化字符需求可以继续添加，必须转化成字符串
    };
    for (let n in i)
      r = new RegExp("(" + n + ")").exec(t), r && (t = t.replace(
        r[1],
        r[1].length == 1 ? i[n] : i[n].padStart(r[1].length, "0")
      ));
    return t;
  } else
    return e;
}
function doExpression(e, t = /* @__PURE__ */ new Set()) {
  let r = e.indexOf("${"), i = e.indexOf("}");
  if (r >= 0 && i > r) {
    let n = e.substring(r + 2, i);
    t.add(n), t = doExpression(e.substr(i + 1), t);
  }
  return t;
}
function converUrl(e) {
  if (e) {
    let t = e.split("/"), r = t[0];
    if (r || (t.splice(0, 1), r = t[0]), r.startsWith("mftcc-")) {
      let i = r.split("-")[1];
      window.$servers && window.$servers[i] && (t.splice(0, 1), e = window.$servers[i] + "/" + t.join("/"));
    }
  }
  return e;
}
function clone(e) {
  return JSON.parse(JSON.stringify(e));
}
function isObjEqual(e, t) {
  let r = this.clone(e);
  delete r.isRowEdit, delete r.isNewRow, delete r.isEditRow, delete r.editRowIndex, delete r.editFieldName;
  for (var i = Object.getOwnPropertyNames(r), n = 0, s = i.length; n < s; n++) {
    var f = i[n];
    let a = e[f], o = t[f];
    if (Array.isArray(a) && (a = a.join("|")), Array.isArray(o) && (o = o.join("|")), a != o)
      return !1;
  }
  return !0;
}
function isTimestamp(e) {
  return typeof e == "number" && (e + "").length == 13;
}
const formUtil = {
  getParmDic,
  getParmDicSync,
  isEmpty,
  isFunction,
  delcommafy,
  toMoney,
  func_uior_valTypeImm,
  bigAmt,
  validateInt,
  validateLong,
  validateNumber,
  validateDate,
  validateFloat,
  validateBoolean,
  validateMoney,
  validateIdNo,
  formatMoney,
  evalFunc,
  numAdd,
  numSub,
  numMulti,
  numDiv,
  parentVmExist,
  desensitization,
  formatDate,
  dateFormat,
  doExpression,
  converUrl,
  parsFieldName,
  clone,
  isNumber,
  isObjEqual,
  isTimestamp
};
export {
  formUtil as default
};
